#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "allegro.h"
#include "lmuse.h"
#include "help.h"



int productionmenuhelp();
int mapsmenuhelp();
int editmenuhelp();
int mutatemenuhelp();
int optionsmenuhelp();
MENU menushelp_menu[] =
{
   { "&Production",                 productionmenuhelp,   NULL },
   { "&Maps",                       mapsmenuhelp,         NULL },
   { "&Edit",                       editmenuhelp,         NULL },
   { "m&Utate",                     mutatemenuhelp,       NULL },
   { "&Options",                    optionsmenuhelp,      NULL },
   { NULL,                          NULL,             NULL }
};


#define HELPBOXMAXW 600
#define HELPBOXMAXH 440
#define HELPTEXTWOFFSET 4
#define HELPTEXTHOFFSET 27
DIALOG  help_dialog[] =
{

   { d_box_proc,         0,   0,    HELPBOXMAXW,    HELPBOXMAXH,     255, HELPBG,  0,   0,      0,    0, NULL},
   { d_textbox_proc,     2,   25,   HELPBOXMAXW-HELPTEXTWOFFSET,  HELPBOXMAXH-HELPTEXTHOFFSET,  255,  0,      0,   0,      0,    0, NULL},
   { d_button_proc,      5,   5,    20,             16,              255,  0,      27,  D_EXIT, 0,    0,    "X" },

   { NULL,               0,     0,    0,    0,   0,    0,    0,     0,      0,    0,    NULL }
};
#define HELPBOX 0
#define HELPTEXTBOX 1


int usehelpfont=1;
int helper(int whichhelp){
   char *helpfilepath=NULL;
   DATAFILE *helpdata;
   char *credittext=NULL;
   long sz;
   char *hd;
   FONT *holdfont=font;


   helpfilepath = getenv("LMUSHELP");
   if (helpfilepath == NULL) helpfilepath = "help.dat";
   
   helpdata=load_datafile(helpfilepath);
   if (helpdata== 0) {

             alert("Error reading help.dat", NULL, NULL, "Oh well","Curses!", 13, 13);
             return D_O_K;
   }
   help_dialog[HELPTEXTBOX].w=help_dialog[HELPBOX].w-HELPTEXTWOFFSET;
   help_dialog[HELPTEXTBOX].h=help_dialog[HELPBOX].h-HELPTEXTHOFFSET;;
   if(usehelpfont)
       font=helpdata[HELPFONT].dat;
   hd=helpdata[whichhelp].dat;
   sz=helpdata[whichhelp].size;
   hd[sz-1]='\0';
   if(whichhelp==CREDITHELP){ /*add up-to-date information to credits*/
      credittext=(char *)malloc(sizeof(char)*(sz+256));
      if(credittext==NULL)
           help_dialog[HELPTEXTBOX].dp=helpdata[whichhelp].dat;
      else{
            sprintf(credittext,"LMUSe version %s, %s\n",PROGRAMVERSION,VERSIONDATE);
            strcat(credittext,helpdata[whichhelp].dat);
            help_dialog[HELPTEXTBOX].dp=credittext;
      }
   }
   else
      help_dialog[HELPTEXTBOX].dp=helpdata[whichhelp].dat;
   help_dialog[HELPTEXTBOX].d2=0;
   centre_dialog(help_dialog);
   popup_dialog(help_dialog,0);
   unload_datafile(helpdata);
   if(credittext!=NULL)
       free(credittext);
   font=holdfont;
   return D_O_K;
}

int symbolshelp(){
   int ret;
   //usehelpfont=0;
   help_dialog[HELPBOX].w=HELPBOXMAXW-230;
   help_dialog[HELPBOX].h=HELPBOXMAXH;

   ret=helper(SYMBOLSHELP);
   //usehelpfont=1;
   return ret;
}
int commandlinehelp(){
   int ret;
   help_dialog[HELPBOX].w=HELPBOXMAXW-100;
   help_dialog[HELPBOX].h=HELPBOXMAXH;

   ret=helper(COMMANDLINEHELP);
   return ret;
}

int playhelp(){
   int ret;
   help_dialog[HELPBOX].w=HELPBOXMAXW-200;
   help_dialog[HELPBOX].h=HELPBOXMAXH-200;

   ret=helper(PLAYHELP);
   return ret;
}

int lsystemshelp(){
   int ret;
   help_dialog[HELPBOX].w=HELPBOXMAXW-100;
   help_dialog[HELPBOX].h=HELPBOXMAXH;

   ret=helper(LSYSHELP);
   return ret;
}

int midihelp(){
   int ret;
   help_dialog[HELPBOX].w=HELPBOXMAXW-250;
   help_dialog[HELPBOX].h=HELPBOXMAXH;

   ret=helper(MIDIHELP);
   return ret;
}
int productionmenuhelp(){
   int ret;
   help_dialog[HELPBOX].w=HELPBOXMAXW-250;
   help_dialog[HELPBOX].h=HELPBOXMAXH;

   ret=helper(PRODUCTIONMENUHELP);
   return ret;
}

int editmenuhelp(){
   int ret;
   help_dialog[HELPBOX].w=HELPBOXMAXW-250;
   help_dialog[HELPBOX].h=HELPBOXMAXH;

   ret=helper(EDITMENUHELP);
   return ret;
}

int mutatemenuhelp(){
   int ret;
   help_dialog[HELPBOX].w=HELPBOXMAXW-250;
   help_dialog[HELPBOX].h=HELPBOXMAXH;

   ret=helper(MUTATEMENUHELP);
   return ret;
}
int mapsmenuhelp(){
   int ret;
   help_dialog[HELPBOX].w=HELPBOXMAXW-250;
   help_dialog[HELPBOX].h=HELPBOXMAXH;

   ret=helper(MAPSMENUHELP);
   return ret;
}

int optionsmenuhelp(){
   int ret;
   help_dialog[HELPBOX].w=HELPBOXMAXW-250;
   help_dialog[HELPBOX].h=HELPBOXMAXH;

   ret=helper(OPTIONSMENUHELP);
   return ret;
}


int scaleshelp(){
   int ret;
   help_dialog[HELPBOX].w=HELPBOXMAXW-350;
   help_dialog[HELPBOX].h=HELPBOXMAXH;

   ret=helper(SCALESHELP);
   return ret;
}

int credithelp(){
   int ret;
   help_dialog[HELPBOX].w=HELPBOXMAXW-350;
   help_dialog[HELPBOX].h=HELPBOXMAXH-150;

   ret=helper(CREDITHELP);
   return ret;
}

int fileshelp(){
   int ret;
   help_dialog[HELPBOX].w=HELPBOXMAXW-150;
   help_dialog[HELPBOX].h=HELPBOXMAXH;

   ret=helper(FILESHELP);
   return ret;
}
int troublehelp(){
    int ret;
    help_dialog[HELPBOX].w=HELPBOXMAXW-150;
    help_dialog[HELPBOX].h=HELPBOXMAXH;

    ret=helper(TROUBLEHELP);
    return ret;
}
int rulefilehelp(){
    int ret;
    help_dialog[HELPBOX].w=HELPBOXMAXW-200;
    help_dialog[HELPBOX].h=HELPBOXMAXH-100;

    ret=helper(RULEFILEHELP);
    return ret;
}
int maphelp(){
    int ret;
    help_dialog[HELPBOX].w=HELPBOXMAXW-150;
    help_dialog[HELPBOX].h=HELPBOXMAXH;

    ret=helper(MAPHELP);
    return ret;
}

int instrumentshelp(){
    int ret;
    help_dialog[HELPBOX].w=HELPBOXMAXW-50;
    help_dialog[HELPBOX].h=HELPBOXMAXH;

    ret=helper(INSTRUMENTHELP);
    return ret;
}

extern unsigned char trackchannel[];
extern volatile long int_t1;
void all_notes_off(int channel);
int playhelpbutton_proc(int msg, DIALOG *d, int c){
        long holdt1;
        int tracknumber;
        int sret;

        int ret=d_button_proc(msg, d, c);

        if(ret==D_CLOSE){


           for(tracknumber=0;tracknumber<MAXTRACKS;tracknumber++){
                all_notes_off(trackchannel[tracknumber]);
           }

           holdt1=int_t1;

           sret=playhelp();
           int_t1=holdt1;
           return sret;
        }
        return(ret);
}


DIALOG overview_dialog[]={

   {d_box_proc,      0,   0,   474,  356,   255,  HELPBG,       0,   0,      0,   0,   NULL},

   {d_bitmap_proc,   1,   25,  472,  330,  255,  0,       0,   0,      0,   0,   NULL},
   { d_button_proc,  5,   5,   30,   16,   255,  0,       13,  D_EXIT, 0,   0,    "OK" },
   { NULL,           0,   0,    0,    0,    0,    0,       0,   0,      0,   0,    NULL }
};
#define OVERVIEWPIC 1
int overview(){
    DATAFILE *helpdata;
    BITMAP * overviewpic;
    char *helpfilepath= getenv("LMUSHELP");
    if (helpfilepath == NULL) helpfilepath = "help.dat";

    helpdata=load_datafile(helpfilepath);
    if (helpdata== 0) {

             alert("Error reading help.dat", NULL, NULL, "Oh well","Curses!", 13, 13);
             return D_O_K;
    }

    overviewpic=helpdata[OVERVIEWBMP].dat;
    if(overviewpic){
           overview_dialog[OVERVIEWPIC].dp=overviewpic;
           centre_dialog(overview_dialog);
           popup_dialog(overview_dialog,2);
           destroy_bitmap(overviewpic);
    }
    unload_datafile(helpdata);
    return D_O_K;

}

int sysinfo()
{
   char *systext, *s;

   systext = malloc(65536);
   if(systext==NULL) return D_O_K;
   systext[0] = 0;

   check_cpu();

   strcpy(systext, "System Information\n==================\n");

   switch (os_type) {
      case OSTYPE_UNKNOWN:    s = "DOS";                     break;
      case OSTYPE_WIN3:       s = "Windows 3.1 or earlier"; break;
      case OSTYPE_WIN95:      s = "Windows 95";              break;
      case OSTYPE_WINNT:      s = "Windows NT";              break;
      case OSTYPE_OS2:        s = "OS/2";                    break;
      case OSTYPE_WARP:       s = "OS/2 Warp 3)";             break;
      case OSTYPE_DOSEMU:     s = "Linux DOSEMU";           break;
      case OSTYPE_OPENDOS:    s = "Caldera OpenDOS";         break;
      default:                s = "Unknown";                break;
   }

   sprintf(systext+strlen(systext), "Platform: %s\n", s);

   sprintf(systext+strlen(systext), "CPU: %s %d86", cpu_vendor, cpu_family);

   if (cpu_fpu)
      strcat(systext, ", FPU");

   if (cpu_mmx)
      strcat(systext, ", MMX");

   if (cpu_3dnow)
      strcat(systext, ", 3DNow!");

   strcat(systext, "\n");

   sprintf(systext+strlen(systext), "\nVideo: %s, %dx%d, %d bpp\n%s\n", gfx_driver->name, SCREEN_W, SCREEN_H, bitmap_color_depth(screen), gfx_driver->desc);

   sprintf(systext+strlen(systext), "\nAudio: %s\n%s\n", digi_driver->name, digi_driver->desc);

   sprintf(systext+strlen(systext), "\nMIDI: %s\n%s\n", midi_driver->name, midi_driver->desc);

   help_dialog[HELPTEXTBOX].dp=systext;
   help_dialog[HELPTEXTBOX].d2=0;

   help_dialog[HELPBOX].w=HELPBOXMAXW-250;
   help_dialog[HELPBOX].h=HELPBOXMAXH-200;
   help_dialog[HELPTEXTBOX].w=help_dialog[HELPBOX].w-HELPTEXTWOFFSET;
   help_dialog[HELPTEXTBOX].h=help_dialog[HELPBOX].h-HELPTEXTHOFFSET;;
   
   centre_dialog(help_dialog);
   popup_dialog(help_dialog,0);

   free(systext);

   return D_O_K;
}



