/* lmuse.c: the main file*/
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <dir.h>
#include <dos.h>
#include <ctype.h>
#include <time.h>

#include "allegro.h"
#include "midifile.h"
#include "lmuse.h"
#include "ldat.h"


BEGIN_GFX_DRIVER_LIST
        GFX_DRIVER_VBEAF
        //GFX_DRIVER_VGA     /*not enough resolution*/
        //GFX_DRIVER_MODEX   /*not enough resolution*/
        GFX_DRIVER_VESA3
        GFX_DRIVER_VESA2L
        GFX_DRIVER_VESA2B
        //GFX_DRIVER_XTENDED /*not enough resolution*/
        GFX_DRIVER_VESA1
END_GFX_DRIVER_LIST


DECLARE_COLOR_DEPTH_LIST(
            COLOR_DEPTH_8
        )


/*extern prod.c*/
int L_mutate(void); char * formatline(char *line);
void initrules(); int readrulefile(FILE *fp);
int makeproduction(int maxlevel);
extern char productionmessage[];
extern char *production;
extern long maxstringlength;
extern char *rules[];
extern int numrules;
extern FILE *rulefilefp;
extern char axiom[];


/*extern maps.c*/
extern MAP maps[MAXMAPS];
extern int cureditmap;
int  do_mconnect_dialog(int mnum); int init_maps();
int getinibutton_proc(int msg,DIALOG *d, int c);
int writeinifile(int mapnumber);

/* extern play.c*/
void all_notes_off(int channel);
extern DIALOG play_dialog[];

/*extern midifile.c*/
int WriteTempoTrack(FILE *fp);

/*extern help.c*/
extern MENU menushelp_menu[];
int symbolshelp(); int lsystemshelp(); int scaleshelp();  int playhelp();
int credithelp();  int fileshelp(); int overview();    int troublehelp();
int rulefilehelp(); int maphelp(); int instrumentshelp(); int midihelp();
int commandlinehelp();
int sysinfo();

/*extern scales.c*/

/*extern draw.c*/
extern int maxcolor;
extern float drawingscale;
extern int drawleftx;
extern int drawrightx;
extern int drawbottomy;
extern int drawtopy;
int getdrawinglimits();
void virline(BITMAP * bmp,float x1,float y1, float x2, float y2, int clr);
int dump_drawing();

/*extern lfsel.c*/
int popup_file_select(char *message, char *path, char *ext);
int do_savefiledialog(char * message,char * filenamebuf, char * ext);
int Lgfx_mode_select(int *card, int *w, int *h);

/*extern interpret.c*/
int interpret (int mode);
int init_trackstuff();
void free_midi_note_list( MIDINOTELIST  * M);
void print_curstate();
void sprint_curstate(char *buffer);
extern float maxx,maxy,maxz,minx,miny,minz;
extern float fmaxx,fmaxy,fmaxz,fminx,fminy,fminz;
extern float umaxx,umaxy,umaxz,uminx,uminy,uminz;
extern float lmaxx,lmaxy,lmaxz,lminx,lminy,lminz;
extern float maxlength, minlength;
extern float maxdrawlength, mindrawlength;
extern float maxthickness, minthickness;
extern float dmultiplier, pspread, dspread, vspread;
extern int numobjects;
extern unsigned char trackchannel[];
extern unsigned char trackflags[];
extern long maxcumtime;
extern float deltaanglerad;
extern MIDINOTELIST * tracklist[];
extern MIDINOTELIST * tracklastnode[];
extern MIDINOTELIST * tracknextnode[];
extern char curstatestring[];
/*-------------------*/

BITMAP *waitmouset,*waitmouseb,*waitmouseu,*waitmousep,*pointup;
BITMAP * lmtitle;


int allegroexiterror(char * s){
     alert(s,"Exiting..",NULL, "OK",NULL,13,0);
     allegro_exit();
     exit(1);
}

void arithmeticerrorhandler(){

    allegro_exit();
    print_curstate();
    exit(0);

}
END_OF_FUNCTION(arithmeticerrorhandler);

int esc_or_right_mouse_button_pressed(){
     return (keypressed()&&((readkey() >> 8) == KEY_ESC))||(mouse_b&2);
}

FILE *savemf_fp;
int myputc(int c) {return(putc(c,savemf_fp));}

#if defined(SCREENDUMPS)
int dump_screen();
#endif

int videocard=GFX_AUTODETECT, videow=DEF_SCREENWIDTH, videoh=DEF_SCREENHEIGHT;
int soundcard=DIGI_AUTODETECT,midicard= MIDI_AUTODETECT;

char * changefileext(char * origfilename,char * newfilename, char * newext);
int do_midisave();
char savemidifile[256] = "";
char mutationfile[256]="mutation.lm";

char inifile[256]="lmuse.ini";

char productionfile[256]="prod.out";
char productionfilename[80];

char rulefile[256]="";
char rulefilename[80]="";
char playrulefilename[80]="";

char editorpath[256]="";

int readconfigfile();
int writeconfigfile();

char *rulesstring=NULL;

char numrecursestring[8]="";
char thickstring[80]="";
char deltaanglestring[80]="10.0";
char numrulesstring[80]="transformation rules (0):";

unsigned rstart,seed;
unsigned lastseed;

int maxlevel;
float thick=10.0;
float deltaangledeg=10.0;

char screendumpextension[4]="PCX";

/* various flags */
int originalmutated=0;
int unsavedrulechanges=0;
int unsavedmapchanges=0;
int autoplay=1;
int draw_p=1;
int writeparameters_p=1;
int randomize_p=1;
int soundoff=0;
int splittracksbyprogram=0;
int useinifile=0;
/*-------------------------*/
int numloopstosave=1;
/*-------------------------*/
int division=DIVISION;
long mtempo;
long tempo=120;
int baset;
/*------------------------*/
char introinfo1[80]="";
DIALOG intro_dialog[]={
/*   (dialog proc)           (x)   (y)   (w)   (h)   (fg)  (bg)   (key) (flags)  (d1)  (d2)  (dp) */

   { d_shadow_box_proc,      0,    0,    209,  140,  255,96,    0,    0,      0,   0,    NULL},
   { d_bitmap_proc,          5,    5,    199,  114,  255,96,    0,    0,      0,   0,    NULL},

   { d_ctext_proc,           104,    123,  0,    0,    255,96,    0,0,0,0, introinfo1},

   { d_button_proc,          120,   62,  30,   16,   255, 0,     13,  D_EXIT,  0,   0,    "OK" },
#if defined(SCREENDUMPS)
   {d_keyboard_proc,    0,    0,   0,    0,    0,    0,     'p'-'a'+1,   0,       0,   0,    dump_screen},
#endif
   { NULL,              0,    0,   0,    0,    0,    0,       0,    0,      0,   0,    NULL }
};
#define INTROLOGOBMP 1
#define INTROTEXT1 2
#define INTROOKBUTTON 3

#if defined(SCREENDUMPS)
int dump_screen(){

     int dumpnumber=0;
     BITMAP *bmp;
     PALETTE pal;
     char filename[80];

     sprintf(filename,"scrdmp%02d.%s",dumpnumber,screendumpextension);
     while (exists(filename)){
           dumpnumber++;
           if(dumpnumber>99){
                alert("Can't find a unique filename","You may have to rename or delete some 'SCRDMP' files",NULL,"OK",NULL,13,0);
                return D_O_K;
           }
           sprintf(filename,"scrdmp%02d.%s",dumpnumber,screendumpextension);

     }
     get_palette(pal);
     show_mouse(NULL);
     bmp = create_sub_bitmap(screen, 0, 0, SCREEN_W-1, SCREEN_H-1);

     save_bitmap(filename, bmp, pal);
     show_mouse(screen);
     destroy_bitmap(bmp);

     alert("Screen saved to",filename,NULL,"OK",NULL,13,0);

     return D_O_K;
}
#endif

unsigned makeseed(){
     struct time t;
     gettime(&t);
     return (unsigned)(t.ti_hund*t.ti_sec);
}

void randomize (){

     lastseed=makeseed();
     srand (lastseed);

}
volatile long int_t1;
void t_int1(){
     int_t1++;

}
END_OF_FUNCTION (t_int1);

void timertempo(long tempo){
        mtempo=60000000/tempo;
        baset=division*tempo;
        if(install_int_ex(t_int1,BPM_TO_TIMER(baset))<0){
                allegroexiterror("Error initializing timer (too many timers?)");
        }
}


int do_makeandinterpret();
int do_remakeandinterpret();
int do_makeproduction();
int do_remakeproduction();
int do_interpret();
int do_interpretremap();
int do_getproduction();
int do_testplay();
int quitter();
int do_dosshell();
int editrulefile();
int editrules();
int geteditor();
int mutaterules();
int mutateandremake();
int savemutation();
int saverulesas();
int getinifile();
int saveinifile();
int do_viewproduction();
int do_playmidifile();
int do_stopmidifile();

int loadnewrules();
MENU production_menu[] =
{
   { "Load, &Make && Interpret",do_makeandinterpret,   NULL },
   { "     Load Rules",             loadnewrules,     NULL },
   { "     Ma&ke Production",       do_makeproduction,     NULL,D_DISABLED },
   { "     &Interpret Production",  do_interpret,          NULL, D_DISABLED},
   { "  R&eMake && Interpret",       do_remakeandinterpret, NULL,D_DISABLED },
   { "  &Re-Interpret (Remap)",      do_interpretremap,     NULL, D_DISABLED},
   { "  &Play",                      do_testplay,           NULL, D_DISABLED},
   { "",                             NULL,                  NULL },
   { "Save Rule File &As ...",       saverulesas,           NULL, D_DISABLED},
   { "",                             NULL,                  NULL },
   { "&View/Save Production",        do_viewproduction,     NULL},
   { "&Get Production",              do_getproduction,      NULL },
   { "",                             NULL,                  NULL },
   { "&Save interpretation as MIDI", do_midisave,              NULL, D_DISABLED},

   { "",                             NULL,                  NULL },
   { "Load a Map file",              getinifile,           NULL },
   { "Save Map",                     saveinifile,           NULL },
   { "",                             NULL,                  NULL },
   { "Save Drawing",                     dump_drawing,           NULL },
   { "",                             NULL,                  NULL },
   { "P&lay a MIDI file",              do_playmidifile,       NULL},
   { "St&op Playing MIDI file\tCTRL-s",do_stopmidifile,     NULL,D_DISABLED},
   { "",                             NULL,                  NULL },
   { "&DOS shell",                    do_dosshell,           NULL},
   { "",                             NULL,                  NULL },
   { "&Quit\tCTRL-q",                quitter,               NULL },
   { NULL,                           NULL,                  NULL }
};
#define PRODMAKE 2
#define PRODINTERP 3
#define PRODREMAKE 4
#define PRODINTERPREMAP 5
#define PRODPLAY 6
#define PRODSAVERULES 8
#define PRODVIEW 10
#define PRODSAVE 13

#define PRODSTOPPLAY 21

int do_remap();
MENU map_menu[] =
{
   { "&0",               do_remap,           NULL },
   { "&1",               do_remap,           NULL },
   { "&2",               do_remap,           NULL },
   { "&3",               do_remap,           NULL },
   { "&4",               do_remap,           NULL },
   { "&5",               do_remap,           NULL },
   { "&6",               do_remap,           NULL },
   { "&7",               do_remap,           NULL },
   { "&8",               do_remap,           NULL },
   { "&9",               do_remap,           NULL },

   { NULL,                 NULL,                   NULL }
};
int do_remap(){
        int i;
        for (i=0;i<MAXMAPS;i++){
              if (&map_menu[i]==active_menu)
                  break;
        }
        do_mconnect_dialog(i);
        return D_O_K;
}

MENU edit_menu[] =
{
   { "&Edit rule file",    editrulefile,           NULL},
   { "Edit &Rules in memory\tCTRL-e",editrules,NULL},
   { "&Pick editor",            geteditor,              NULL},
   { NULL,                 NULL,                   NULL }
};
#define EDITEDIT 0


MENU mutate_menu[] =
{
   { "&Mutate rules\tCTRL-m",          mutaterules,           NULL,D_DISABLED},
   { "Mutate && &Remake/Interpret",    mutateandremake,       NULL,D_DISABLED},
   { "&Save Mutated rules",            savemutation,          NULL,D_DISABLED},

   { NULL,                 NULL,                   NULL }
};
#define MUTATEMUTATE 0
#define MUTATEREMAKE 1
#define MUTATESAVE 2

int vw; /* view */
DIALOG view_dialog[]=
{

   {d_box_proc,               300,  30,   220,  192,   255,   0,       0,   0,      0,   0,   NULL},
   {d_text_proc,              310,  44,   0,    0,     255,   0,       0,   0,      0,   0,   "View Plane"},
   {d_radio_proc,             310,  60,   40,   10,     255,   0,       0,   0,      0,   0,   "XY"},
   {d_radio_proc,             310,  72,   40,   10,     255,   0,       0,   0,      0,   0,   "ZY"},
   {d_radio_proc,             310,  84,   40,   10,     255,   0,       0,   0,      0,   0,   "ZX"},

   {d_text_proc,              310,  104,   0,    0,     255,   0,       0,   0,      0,   0,   "Size"},
   {d_radio_proc,             310,  120,   40,   10,     255,   0,       0,   0,      1,   0,   "Full"},
   {d_radio_proc,             310,  132,   40,   10,     255,   0,       0,   0,      1,   0,   "1/2"},
   {d_radio_proc,             310,  144,   40,   10,     255,   0,       0,   0,      1,   0,   "1/3"},
   {d_radio_proc,             310,  156,   40,   10,     255,   0,       0,   0,      1,   0,   "1/4"},
   {d_radio_proc,             310,  168,   40,   10,     255,   0,       0,   0,      1,   0,   "1/8"},

   {d_text_proc,              390,  144,   0,    0,     255,   0,       0,   0,      0,   0,   "File Type for"},
   {d_text_proc,              390,  156,   0,    0,     255,   0,       0,   0,      0,   0,   "Saved Drawings"},
   {d_radio_proc,             390,  172,   40,   10,     255,   0,       0,   0,      2,   0,   "BMP"},
   {d_radio_proc,             390,  184,   40,   10,     255,   0,       0,   D_SELECTED,      2,   0,   "PCX"},
   {d_radio_proc,             390,  196,   40,   10,     255,   0,       0,   0,      2,   0,   "TGA"},

   { d_button_proc,           310,  192,   30,   24,    255,  0,       13,D_EXIT,    0,   0,    "OK" },
   { NULL,                    0,    0,     0,    0,     0,     0,       0,   0,      0,   0,    NULL }
};
#define VIEWRADIO1 2
#define SIZERADIO1 6
#define SAVEDRAWINGTYPERADIO1 13
int do_view_dialog(){
    int i;
    int ret;
    int ndrawscale=0;

    for(i=0;i<3;i++){
            view_dialog[VIEWRADIO1+i].flags &= ~D_SELECTED;
    }
    for(i=0;i<5;i++){
            view_dialog[SIZERADIO1+i].flags &= ~D_SELECTED;
    }
    view_dialog[VIEWRADIO1+vw].flags |= D_SELECTED;
    switch((int)drawingscale){
        case 1: ndrawscale=0; break;
        case 2: ndrawscale=1; break;
        case 3: ndrawscale=2; break;
        case 4: ndrawscale=3; break;
        case 8: ndrawscale=4; break;
    }
    view_dialog[SIZERADIO1+ndrawscale].flags |= D_SELECTED;

    for(i=0;i<3;i++){
        view_dialog[SAVEDRAWINGTYPERADIO1+i].flags &= ~D_SELECTED;

    }
    if(!stricmp(screendumpextension,"BMP"))
         view_dialog[SAVEDRAWINGTYPERADIO1+0].flags |= D_SELECTED;
    else if(!stricmp(screendumpextension,"PCX"))
         view_dialog[SAVEDRAWINGTYPERADIO1+1].flags |= D_SELECTED;
    else if(!stricmp(screendumpextension,"TGA"))
         view_dialog[SAVEDRAWINGTYPERADIO1+2].flags |= D_SELECTED;


    ret=popup_dialog(view_dialog,0);

    for(i=0;i<3;i++){
            if(view_dialog[VIEWRADIO1+i].flags&D_SELECTED)
                 vw=i;
            view_dialog[VIEWRADIO1+i].flags &= ~D_SELECTED;
   }
    for(i=0;i<5;i++){
            if(view_dialog[SIZERADIO1+i].flags&D_SELECTED)
                 switch(i){
                    case 0: drawingscale=1; break;
                    case 1: drawingscale=2; break;
                    case 2: drawingscale=3; break;
                    case 3: drawingscale=4; break;
                    case 4: drawingscale=8; break;
                 }

            view_dialog[SIZERADIO1+i].flags &= ~D_SELECTED;
   }

   if(view_dialog[SAVEDRAWINGTYPERADIO1+0].flags& D_SELECTED)
             strcpy(screendumpextension,"BMP");
   else if(view_dialog[SAVEDRAWINGTYPERADIO1+1].flags& D_SELECTED)
             strcpy(screendumpextension,"PCX");

   else if(view_dialog[SAVEDRAWINGTYPERADIO1+2].flags& D_SELECTED)
             strcpy(screendumpextension,"TGA");
   for(i=0;i<3;i++){
            view_dialog[SAVEDRAWINGTYPERADIO1+i].flags &= ~D_SELECTED;
   }

   return D_O_K;
}
int soundtoggle();
int drawtoggle();
int autoplaytoggle();
int do_maxstringsizedialog();
MENU options_menu[] =
{
   { " Sound",            soundtoggle,          NULL },
   { " Draw",             drawtoggle,           NULL },
   { " Auto Play",        autoplaytoggle,       NULL },
   { "",               NULL,NULL},
   { "View...",           do_view_dialog,       NULL },
   { "Maximum production string size",do_maxstringsizedialog,NULL},

   { NULL,                 NULL,                   NULL }
};

#define SOUNDTOGGLE 0
#define DRAWTOGGLE 1
#define AUTOPLAYTOGGLE 2
#define MAXSTRING 5


MENU help_menu[] =
{

   { "process &Overview",           overview,               NULL },
   { "&Menus && buttons",           NULL,                   menushelp_menu},
   { "&Symbol alphabet",            symbolshelp,            NULL },
   { "m&Aps && map files",          maphelp,                NULL },
   { "&Rule file format",           rulefilehelp,           NULL },
   { "s&Cales",                     scaleshelp,             NULL },
   { "instrument/timbre &Numbers",  instrumentshelp,        NULL },
   { "m&Idi files",                 midihelp,               NULL},
   { "&Play",                       playhelp,               NULL },
   { "&DOS command line",           commandlinehelp,        NULL },
   { "&Trouble",                    troublehelp,            NULL },
   { "&L-systems",                  lsystemshelp,           NULL },
   { "rules c&Ompatibility",         fileshelp,              NULL },
   { "s&Yystem info",                sysinfo,                NULL},
   { "LMUSe c&Redits",               credithelp,             NULL },
   { NULL,                          NULL,                   NULL }
};

MENU topmenu[] =
{ 
   { "&Production",                 NULL,            production_menu },
   { "&Maps",                       NULL,            map_menu},
   { "&Edit",                       NULL,            edit_menu},
   { "m&Utate",                     NULL,            mutate_menu},
   { "&Options",                    NULL,            options_menu},
   { "&Help",                       NULL,            help_menu },

   { NULL,                          NULL,            NULL }
};
#define TOPMUTATE 3


char process_status_string[80]="";

int d_quit_icon_proc(int msg,DIALOG *d, int c);
int d_remap_icon_proc(int msg,DIALOG *d, int c);
int d_interpret_icon_proc(int msg,DIALOG *d, int c);
int d_play_icon_proc(int msg,DIALOG *d, int c);
int d_savemidi_icon_proc(int msg,DIALOG *d, int c);
int d_makeandinterpret_icon_proc(int msg,DIALOG *d, int c);
int d_remake_icon_proc(int msg,DIALOG *d, int c);
int d_loadrules_icon_proc(int msg,DIALOG *d, int c);
int d_make_icon_proc(int msg,DIALOG *d, int c);
int d_edit_icon_proc(int msg,DIALOG *d, int c);
int d_editrules_icon_proc(int msg,DIALOG *d, int c);
int d_mutate_icon_proc(int msg,DIALOG *d, int c);
int d_mutateandinterpret_icon_proc(int msg,DIALOG *d, int c);
int d_saverules_icon_proc(int msg,DIALOG *d, int c);
int loadini_proc(int msg,DIALOG *d, int c);
int saveini_proc(int msg,DIALOG *d, int c);
int rulesinfo_proc(int msg, DIALOG *d, int c);


/*   (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)   (key) (flags)  (d1)  (d2)  (dp) */
DIALOG dialog1[] =
{

   { d_box_proc,        0,    0,   639,  479,  255,  BG1,   0,      0,     0,   0,    NULL},
   { d_box_proc,        DRAWBORDERWIDE,DRAWBORDERWIDE+DRAWINGTOP,639-2*DRAWBORDERWIDE,480-2*DRAWBORDERWIDE-DRAWINGTOP,255,  EMPTYBG,   0,      0,     0,   0,    NULL},
   { d_menu_proc,       0,    0,   0,    0,    0,    0,     0,      0,     0,   0,   topmenu },

/**/ /* buttons */
   { d_shadow_box_proc,              PMBL,   PMBD, 2*BUTTONWIDTH, 9*BUTTONHEIGHT,                    255,PMBG,0,    0,                0,   0,    NULL},

   { rulesinfo_proc,                 PMBL+1,  PMBD+9*BUTTONHEIGHT-18+5,  2*BUTTONWIDTH-2,     16,      15,  0, 'r',  D_EXIT,  0,   0,   rulefilename },

   { d_loadrules_icon_proc,          PMBL+0, PMBD+0,BUTTONWIDTH,BUTTONHEIGHT,                        255,PMBG,0,  D_EXIT,             2,   2,    NULL,NULL,NULL},
   { d_make_icon_proc,               PMBL+0, PMBD+BUTTONHEIGHT,BUTTONWIDTH,BUTTONHEIGHT,                        255,PMBG,0,  D_EXIT|D_DISABLED,             2,   2,    NULL,NULL,NULL},
   { d_makeandinterpret_icon_proc,   PMBL+BUTTONWIDTH,PMBD+0,BUTTONWIDTH,2*BUTTONHEIGHT,               255,PMBG,0,  D_EXIT,             2,   2,    NULL,NULL,NULL},

   { d_interpret_icon_proc,          PMBL+0,PMBD+2*BUTTONHEIGHT,BUTTONWIDTH,BUTTONHEIGHT,              255,PMBG,0,  D_EXIT|D_DISABLED,  2,   2,    NULL,NULL,NULL},
   { d_remake_icon_proc,             PMBL+BUTTONWIDTH,PMBD+2*BUTTONHEIGHT,BUTTONWIDTH,BUTTONHEIGHT,    255,PMBG,0,  D_EXIT|D_DISABLED,  2,   2,    NULL,NULL,NULL},

   { d_remap_icon_proc,              PMBL+0,PMBD+3*BUTTONHEIGHT,BUTTONWIDTH,BUTTONHEIGHT,            255,PMBG,0,  D_EXIT|D_DISABLED,  2,   2,    NULL,NULL,NULL},
   { d_play_icon_proc,               PMBL+BUTTONWIDTH,PMBD+3*BUTTONHEIGHT,BUTTONWIDTH,BUTTONHEIGHT,  255,PMBG,0,  D_EXIT|D_DISABLED,  2,   2,    NULL,NULL,NULL},

   { d_mutate_icon_proc,             PMBL+0,PMBD+4*BUTTONHEIGHT, BUTTONWIDTH,BUTTONHEIGHT,           255,PMBG,0,  D_EXIT|D_DISABLED,  2,   2,    NULL,NULL,NULL},
   { d_mutateandinterpret_icon_proc, PMBL+BUTTONWIDTH, PMBD+4*BUTTONHEIGHT, BUTTONWIDTH,BUTTONHEIGHT,255,PMBG,0,  D_EXIT|D_DISABLED,  2,   2,    NULL,NULL,NULL},


   { d_savemidi_icon_proc,           PMBL+0,PMBD+5*BUTTONHEIGHT, BUTTONWIDTH,BUTTONHEIGHT,255,PMBG,0,  D_EXIT|D_DISABLED,  2,   2,    NULL,NULL,NULL},
   { d_saverules_icon_proc,          PMBL+BUTTONWIDTH,PMBD+5*BUTTONHEIGHT, BUTTONWIDTH,BUTTONHEIGHT, 255,PMBG,0,  D_EXIT|D_DISABLED, 2,   2,    NULL,NULL,NULL},

   { d_edit_icon_proc,               PMBL+0,PMBD+6*BUTTONHEIGHT,BUTTONWIDTH,BUTTONHEIGHT,            255,PMBG,0,  D_EXIT,             2,   2,    NULL,NULL,NULL},
   { d_editrules_icon_proc,          PMBL+BUTTONWIDTH,PMBD+6*BUTTONHEIGHT,BUTTONWIDTH,BUTTONHEIGHT,            255,PMBG,0,  D_EXIT,             2,   2,    NULL,NULL,NULL},

   { d_quit_icon_proc,               PMBL+BUTTONWIDTH/2, PMBD+7*BUTTONHEIGHT, BUTTONWIDTH,BUTTONHEIGHT,255,PMBG,0,  D_EXIT,  2,   2,    NULL,NULL,NULL},
/**/
   { d_keyboard_proc,   0,    0,   0,    0,    0,    0,     0,      0, KEY_ESC, 0,   quitter },
   { d_keyboard_proc,   0,    0,   0,    0,    0,    0,     C('q'), 0,     0,   0,   quitter },

   { d_keyboard_proc,   0,    0,   0,    0,    0,    0,     C('m'), 0,     0,   0,    mutaterules },
   { d_keyboard_proc,   0,    0,   0,    0,    0,    0,     C('s'), 0,     0,   0,    do_stopmidifile },
   { d_keyboard_proc,   0,    0,   0,    0,    0,    0,     C('e'), 0,     0,   0,    editrules },

   { loadini_proc,                 PMBL+1,  PMBD+9*BUTTONHEIGHT-36+5,  2*BUTTONWIDTH-2,     16,      15,  0, 0,  D_EXIT,  0,   0,   "Load Map" },
   { saveini_proc,                 PMBL+1,  PMBD+9*BUTTONHEIGHT-54+5,  2*BUTTONWIDTH-2,     16,      15,  0, 0,  D_EXIT,  0,   0,   "Save Map" },

   { d_text_proc,        400,    5,   238,  12,  18,  BG1,   0,      0,     0,   0,    process_status_string},
#if defined (SCREENDUMPS)
   {d_keyboard_proc,    0,    0,   0,    0,    0,    0,     'p'-'a'+1,   0,       0,   0,    dump_screen},
#endif
   {d_keyboard_proc,    0,    0,   0,    0,    0,    0,     'd'-'a'+1,   0,       0,   0,    dump_drawing},
   { NULL,              0,    0,   0,    0,    0,    0,      0,    0,      0,    0,   NULL }
};

#define DRAWBOX 1
#define TOPMENU 2
#define DIALOG1RULES 4

#define PROCLOADBUT 5
#define PROCMAKEBUT 6
#define PROCMAKEANDBUT 7
#define PROCINTERPBUT  8
#define PROCREMAKEBUT 9
#define PROCREMAPBUT 10
#define PROCPLAYBUT  11
#define PROCMUTATEBUT 12
#define PROCMUTANDBUT  13
#define PROCSAVEMIDIBUT  14
#define PROCSAVERULESBUT 15
#define PROCEDITBUT  16
#define PROCEDITRULESBUT 17

#define PROCQUITBUT  18

#define PROCESSSTATUSTEXT 26

int showprocessstatus(char *message){
     int obj;
     int elength,tlength;
     DIALOG *d=&dialog1[PROCESSSTATUSTEXT];

     elength=text_length(font,d->dp);
     rectfill(screen,d->x, d->y, d->x+d->w, d->y+d->h, BG1);
     tlength=text_length(font,message);
     strcpy(process_status_string,message);
     d->w=tlength;
     dialog_message(d, MSG_DRAW, 0, &obj);
     return 0;
}
int do_openrulefiledialog(){
     int fsret=1,alertret;
     char buf[100];
     while (fsret){
          fsret=popup_file_select("Load Rule File:", rulefile, "l;ls;lm");
          if(fsret==0) return 0;
          if(!exists(rulefile)){
               sprintf(buf, "Can't find %s", rulefile);
               alertret=alert3(buf, NULL, NULL, "OK", "Try again","Cancel", 13,'t', 27) ;
               if(alertret==1) return 0;
               else if (alertret == 3)
                  return 0;
               else if(alertret==2){
                  fsret=1;
               }
          }
          else fsret=0;
     }

     return(1);
}

char seedstring[80]="";
char maxstringlengthstring[80]="";
/*   (dialog proc)           (x)    (y)    (w)   (h)   (fg)  (bg)   (key) (flags)  (d1)  (d2)  (dp) */
DIALOG numrecurse_dialog[] =
{
   {d_box_proc,               100,  100,   500,  290,   255,   0,       0,   0,      0,   0,   NULL},
   {d_text_proc,              110,  110,   0,    0,     255,   0,       0,   0,      0,   0,   rulefile},
   /*production string length*/
   {d_text_proc,              400,  110,   0,    0,     255,   0,       0,   0,      0,   0,   "max production length:"},
   {d_edit_proc,              400,  125,   50,   16,    255,   8,       0 ,  0,     3,   0,   maxstringlengthstring},
   {d_text_proc,              460,  125,   0,    0,     255,   0,       0,   0,      0,   0,   "Megabytes"},
   /*randomize*/
   {d_text_proc,              400,  150,   0,    0,     255,   0,       0,   0,      0,   0,   "Seed:"},
   {d_edit_proc,              450,  150,   60,   16,    255,   8,       0 ,  0,     10,   0,   seedstring},
   {d_check_proc,             400,  165,   116,   10,    255,   0,       0, D_SELECTED, 0, 0,   "Random Seed"},
   /*recursion depth*/
   {d_text_proc,              110,  130,   0,    0,     255,   0,       0,   0,      0,   0,   "recursion depth:"},
   {d_edit_proc,              250,  130,   30,   16,    255,   8,       0 ,  0,      2,   0,   numrecursestring},
   /*angle*/
   {d_text_proc,              110,  150,   0,    0,     255,   0,       0,   0,      0,   0,   "basic angle:"},
   {d_edit_proc,              250,  150,   60,   16,    255,   8,       0 ,  0,      6,   0,   deltaanglestring},
   /*thickness*/
   {d_text_proc,              110,  170,   0,    0,     255,   0,       0,   0,      0,   0,   "thickness:"},
   {d_edit_proc,              250,  170,   60,   16,    255,   8,       0 ,  0,      6,   0,   thickstring},
   /*axiom*/
   {d_text_proc,              110,  190,   0,    0,     255,   0,       0,   0,      0,   0,   "axiom:" },
   {d_textbox_proc,           110,  210,   480,  30,    255,   0,       0,   0,      0,   0,   NULL},
   /*rules*/
   {d_text_proc,              110,  250,   0,    0,     255,   0,       0,   0,      0,   0,   numrulesstring},
   {d_text_proc,              500,  250,   0,    0,     255, MUTATEDBG,       0,   D_HIDDEN,      0,   0,   "Mutated"},
   {d_textbox_proc,           110,  270,   480,  80,    255,   0,       0,   0,      0,   0,   NULL},

   {d_button_proc,            220,  370,   80,   16,    255,   0,       13,  D_EXIT, 0,   0,    "Continue" },

   {d_button_proc,            340,  370,   50,   16,    255,   0,       27,  D_EXIT, 0,   0,    "Stop" },

   { NULL,                    0,    0,     0,    0,     0,     0,       0,   0,      0,   0,    NULL }
};
#define RANDOMIZECHECK 7
#define AXIOMBOX 15
#define MUTATEDTEXT 17
#define RULESBOX 18
#define NUMRECURSECANCEL 20

DIALOG maxstringsize_dialog[] =
{
   {d_box_proc,               260,  30,   300,  65,   255,   0,       0,   0,      0,   0,   NULL},
   {d_text_proc,              280,  40,   0,    0,     255,   0,       0,   0,      0,   0,   "Maximum Production String Length:"},
   {d_edit_proc,              280,  55,   25,   16,    255,   8,       0 ,  0,      2,   0,   maxstringlengthstring},
   {d_text_proc,              320,  55,   0,    0,     255,   0,       0,   0,      0,   0,   "Megabytes"},

   {d_button_proc,            280,  75,   30,   16,    255,   0,       13,  D_EXIT, 0,   0,    "OK" },
   {d_button_proc,            320,  75,   50,   16,    255,   0,       27,  D_EXIT, 0,   0,    "Cancel" },


   { NULL,                    0,    0,     0,    0,     0,     0,       0,   0,      0,   0,    NULL }
};

#define MAXSTRINGSIZECANCEL 5
int do_maxstringsizedialog(){
    int dret;
    long tmsl;
    sprintf(maxstringlengthstring,"%ld",(maxstringlength/(1024*1024)));
    dret=popup_dialog(maxstringsize_dialog,2);

    if(dret==MAXSTRINGSIZECANCEL || dret==-1){
              return D_O_K;
    }


    tmsl=atoi(maxstringlengthstring);
    if(tmsl>=1){
            maxstringlength=1024*1024*(long)tmsl;
    }
    return D_O_K;

}


int getrules( char * rulefile){

   int maxlevel;

   formatline(rulefile);
   if(*rulefile =='\0')
                return -1;

   initrules();
   rulefilefp=fopen(rulefile,"r");
   if(rulefilefp==NULL){

          alert("File not found",NULL,NULL,"OK",NULL,13,0);
          return -1;
   }

   maxlevel=readrulefile(rulefilefp);
   if(maxlevel<0){

          allegroexiterror("Memory Allocation Error");

   }
   originalmutated=0;
   unsavedrulechanges=0;
   sprintf(numrecursestring,"%d",maxlevel);
   sprintf(deltaanglestring,"%3.2f",deltaangledeg);
   sprintf(thickstring,"%3.2f",thick);
   sprintf(numrulesstring,"transformation rules (%d):",numrules);
   fclose(rulefilefp);
   strcpy(rulefilename,get_filename(rulefile));
   changefileext(rulefile,productionfile,"out");
   changefileext(rulefile,savemidifile,"mid");
   changefileext(rulefile,mutationfile,"lm");
   changefileext(get_filename(rulefile),productionfilename,"");
   changefileext(rulefile,inifile,"ini");

   return 0;
}


char * makerulesstring(){
     int i;
     int stringlength=0;

     for (i=0;i<numrules;i++)
          stringlength+=(strlen(rules[i])+2);
     if(rulesstring!=NULL)
         free(rulesstring);
     rulesstring=(char *)malloc(sizeof(char)*stringlength+1);

     if(rulesstring!=NULL){
         *rulesstring='\0';
         for (i=0;i<numrules;i++){
           strcat(rulesstring,rules[i]);
           strcat(rulesstring,"\n");
         }
     }

     return rulesstring;
}
int do_numrecursedialog(int recurse){

   int dret;
   long tmsl;
   if(recurse<0){
       numrecurse_dialog[RULESBOX].dp=makerulesstring();
       numrecurse_dialog[AXIOMBOX].dp=axiom;
       sprintf(maxstringlengthstring,"%ld",(maxstringlength/(1024*1024)));
       sprintf(seedstring,"%u",rstart);
       if(randomize_p){
              numrecurse_dialog[RANDOMIZECHECK].flags |= D_SELECTED;

       }
       else numrecurse_dialog[RANDOMIZECHECK].flags &= ~D_SELECTED;
       originalmutated ? (numrecurse_dialog[MUTATEDTEXT].flags &= ~D_HIDDEN):(numrecurse_dialog[MUTATEDTEXT].flags |= D_HIDDEN);
       centre_dialog(numrecurse_dialog);
       dret=popup_dialog(numrecurse_dialog,-1);

       if(dret==NUMRECURSECANCEL || dret==-1){
              return -1;
       }
       recurse=atoi(numrecursestring);

       deltaangledeg=atof(deltaanglestring);
       thick=atof(thickstring);
       rstart=(unsigned)atoi(seedstring);
       if(numrecurse_dialog[RANDOMIZECHECK].flags & D_SELECTED){
           randomize_p=1;
       }
       else {
            randomize_p=0;
            lastseed=rstart;
       }
       tmsl=atoi(maxstringlengthstring);
       if(tmsl>=1){
            maxstringlength=1024*1024*(long)tmsl;
       }

   }

   return recurse;
}
char productionlengthstring[24]="";
int saveproduction_proc(int msg, DIALOG *d, int c);
/*   (dialog proc)           (x)   (y)   (w)   (h)   (fg)  (bg)   (key) (flags)  (d1)  (d2)  (dp) */
DIALOG viewprod_dialog[] =
{
   {d_box_proc,               0,  0,   480,  300,   255,   4,       0,   0,      0,   0,   NULL},
   {d_text_proc,              200,2,   0,    0,     255,   4,       0,   0,      0,   0,  productionfilename},
   {d_textbox_proc,           0,  15,  480,  255,   255,   0,       0,   D_SELECTED,      0,   0,   NULL},

   {rulesinfo_proc,           5,  280, 100,   16,    255,   0,       'r',  D_EXIT,  0,   0,    "&Rules info" },
   {saveproduction_proc,      120,280, 130,   16,    255,   0,       's',  D_EXIT,  0,   0,    "&Save Production" },
   {d_button_proc,            5,  2,   10,    10,    255,   0,       13,  D_EXIT,  0,   0,    "X" },

   {d_text_proc,              300,280,   0,    0,     255,   4,       0,   0,      0,   0,  productionlengthstring},
   { NULL,              0,    0,   0,    0,    0,    0,       0,    0,      0,   0,    NULL }
};
#define PRODUCTIONTEXT 2

char *emptyproduction="(empty)";
int do_viewproduction(){
        long prodlen=strlen(production);
        production[prodlen]='\n';
        if(prodlen>0)
          viewprod_dialog[PRODUCTIONTEXT].dp=production;
        else
          viewprod_dialog[PRODUCTIONTEXT].dp=emptyproduction;
        sprintf(productionlengthstring,"Length: %ld",prodlen);
        centre_dialog(viewprod_dialog);
        popup_dialog(viewprod_dialog,1);
        production[prodlen]='\0';
        return D_O_K;
}


int rulesinfo_proc(int msg, DIALOG *d, int c){
      int ret=d_button_proc(msg,d,c);
      if(ret==D_CLOSE){
        do_numrecursedialog(-1);
        return D_O_K;
      }
      return ret;
}
void redrawbuttons(){
     int i;
     show_mouse(NULL);
     for (i=PROCLOADBUT;i<=PROCQUITBUT;i++){
          d_icon_proc(MSG_DRAW,&(dialog1[i]),0);
     }
     show_mouse(screen);
}

int makeaborted;
int makefailed;
int loadnewrules(){

   int alertret=0;
   int obj;
   if(unsavedrulechanges){
          alertret=alert3("Unsaved rule changes","Do you want to save?","","Save","Don't save","Cancel",13,0,0);
          if(alertret==1)
                         saverulesas();
          else if(alertret==3){
                         makeaborted=1;
                         return D_O_K;
          }
   }

   makeaborted=0;
   makefailed=0;
   if(do_openrulefiledialog()==0){
                makeaborted=1;
                return D_O_K;
   }
   production_menu[PRODMAKE].flags |= D_DISABLED;
   production_menu[PRODINTERPREMAP].flags |= D_DISABLED;
   production_menu[PRODINTERP].flags |= D_DISABLED;
   dialog1[PROCMAKEBUT].flags |= D_DISABLED;
   dialog1[PROCINTERPBUT].flags |= D_DISABLED;
   dialog1[PROCREMAPBUT].flags |= D_DISABLED;

   if(getrules(rulefile)==-1){
                makeaborted=1;
                return D_O_K;
   }
   dialog1[DIALOG1RULES].bg=UNCHANGEDBG;
   edit_menu[EDITEDIT].flags &= ~D_DISABLED;
   dialog1[PROCEDITBUT].flags &= ~D_DISABLED;
   topmenu[TOPMUTATE].flags &= ~D_DISABLED;
   mutate_menu[MUTATEMUTATE].flags &= ~D_DISABLED;
   mutate_menu[MUTATEREMAKE].flags &= ~D_DISABLED;
   dialog1[PROCMUTATEBUT].flags &= ~D_DISABLED;
   dialog1[PROCMUTANDBUT].flags &= ~D_DISABLED;
   mutate_menu[MUTATESAVE].flags |= D_DISABLED;

   production_menu[PRODMAKE].flags &= ~D_DISABLED;
   production_menu[PRODREMAKE].flags &= ~D_DISABLED;
   production_menu[PRODSAVERULES].flags &= ~D_DISABLED;
   dialog1[PROCMAKEBUT].flags &= ~D_DISABLED;
   dialog1[PROCREMAKEBUT].flags &= ~D_DISABLED;
   dialog1[PROCSAVERULESBUT].flags &= ~D_DISABLED;

   dialog_message(&dialog1[DIALOG1RULES], MSG_DRAW, 0,&obj);
   return D_O_K;
}
int do_makeproduction(){
   int recurse=-1;
   int makeret=0;
   makeaborted=0;
   makefailed=0;

   recurse=do_numrecursedialog(recurse);
   set_mouse_sprite(waitmouseb);

   makeret=makeproduction(recurse);

   if(makeret<0){
           set_mouse_sprite(NULL);
           showprocessstatus("");
           alert("production failed",productionmessage,NULL,"OK",NULL,13,0);
           makefailed=1;
   }
   else if(makeret==1 || recurse<0) {
           set_mouse_sprite(NULL);
           showprocessstatus("");
           alert("production aborted",NULL,NULL,"OK",NULL,13,0);
           makeaborted=1;
           production_menu[PRODINTERP].flags |= D_DISABLED;
           dialog1[PROCINTERPBUT].flags |= D_DISABLED;
           production_menu[PRODMAKE].flags &= ~D_DISABLED;
           dialog1[PROCMAKEBUT].flags &= ~D_DISABLED;

   }
   else {
       production_menu[PRODINTERP].flags &= ~D_DISABLED;
       dialog1[PROCINTERPBUT].flags &= ~D_DISABLED;

   }
   set_mouse_sprite(NULL);
   showprocessstatus("");
   redrawbuttons();

   return D_O_K;
}
int do_remakeproduction(){
   int recurse=-1;
   int makeret=0;
   makeaborted=0;
   makefailed=0;

   recurse=do_numrecursedialog(recurse);

   show_mouse(screen);
   set_mouse_sprite(waitmouseb);

   makeret=makeproduction(recurse);

   if(makeret<0){
           set_mouse_sprite(NULL);
           showprocessstatus("");
           alert("production failed",productionmessage,NULL,"OK",NULL,13,0);
           makefailed=1;
   }
   else if(makeret==1 || recurse<0) {
           set_mouse_sprite(NULL);
           showprocessstatus("");
           alert("production aborted",NULL,NULL,"OK",NULL,13,0);
           production_menu[PRODREMAKE].flags &= ~D_DISABLED;
           production_menu[PRODSAVERULES].flags &= ~D_DISABLED;       
           production_menu[PRODINTERP].flags &= ~D_DISABLED;
           dialog1[PROCREMAKEBUT].flags &= ~D_DISABLED;
           dialog1[PROCSAVERULESBUT].flags &= ~D_DISABLED;
           dialog1[PROCINTERPBUT].flags &= ~D_DISABLED;

           makeaborted=1;
   }
   else {
       production_menu[PRODREMAKE].flags &= ~D_DISABLED;
       production_menu[PRODSAVERULES].flags &= ~D_DISABLED;
       production_menu[PRODINTERP].flags &= ~D_DISABLED;

       dialog1[PROCREMAKEBUT].flags &= ~D_DISABLED;
       dialog1[PROCSAVERULESBUT].flags &= ~D_DISABLED;
       dialog1[PROCINTERPBUT].flags &= ~D_DISABLED;

   }
   set_mouse_sprite(NULL);
   showprocessstatus("");
   redrawbuttons();

   return D_O_K;
}
FILE *readprod_fp;
int do_productionfiledialog(){
     int fsret=1,alertret;
     char buf[100];
     while (fsret){
          fsret=popup_file_select("Get Production File:", productionfile, "out");
          if(fsret==0) return 0;
          if(!exists(productionfile)){
               sprintf(buf, "Can't find %s", productionfile);
               alertret=alert3(buf, NULL, NULL, "OK", "Try again","Cancel", 13,'t', 27) ;
               if(alertret==1) return 0;
               else if (alertret == 3)
                  return 0;
               else if(alertret==2){
                  fsret=1;
               }
          }
          else fsret=0;
     }

     return(1);
}


int do_getproduction(){
   long plength=0L;
   char *ptr;

   long maxlen=maxstringlength-10L;
   int c;

   if(production==NULL){

      production=(char *)malloc(maxstringlength);
      if(production==NULL){
                    sprintf(productionmessage,"Memory Allocation Error");
                    alert(productionmessage,NULL,NULL,"OK",NULL,13,0);
                    return D_O_K;

      }
      
   }
   ptr=production;
   if(do_productionfiledialog()==0){

       return D_O_K;
   }
   else{
       readprod_fp=fopen(productionfile,"r");
       if(readprod_fp==NULL){
              return D_O_K;
       }
       while( (c=fgetc(readprod_fp))!=EOF){
              *ptr=c;
               ptr++;
               plength++;
               if(plength>maxlen){
                     alert("Out of string space",NULL,NULL,"OK",NULL,13,0);
                     return D_O_K;
               }
       }
       fclose(readprod_fp);
       *ptr='\0';

   }
   changefileext(productionfile,savemidifile,"mid");
   changefileext(get_filename(productionfile),productionfilename,"");

   production_menu[PRODINTERP].flags &= ~D_DISABLED;
   dialog1[PROCINTERPBUT].flags &= ~D_DISABLED;


   return D_O_K;
}


int do_makeandinterpret(){
    int mret;
    int loadrulesret;
    loadrulesret=loadnewrules();
    if (makeaborted !=0)
        return D_O_K;
    mret=do_makeproduction();
    if (mret!=D_O_K) return mret;
    if(makeaborted==0 && makefailed==0){

          do_interpret();

    }
    return D_O_K;


}
int do_remakeandinterpret(){
    int mret=do_remakeproduction();
    if (mret!=D_O_K) return mret;
    if(makeaborted==0 && makefailed==0){

          do_interpret();

    }
    return D_O_K;


}
DIALOG aritherrorhelp_dialog[] =
{
   {d_box_proc,               180,  240,   360,   160,   255,   0,       0,   0,      0,   0,   NULL},
   {d_textbox_proc,           200,  242,   330,   130,   255,   0,       0,   0,       0,   0,  NULL},

   { d_button_proc,           200,  380,   30,   16,   255,  0,       13,  D_EXIT,  0,   0,    "OK" },
   { NULL,              0,    0,   0,    0,    0,    0,       0,    0,      0,   0,    NULL }
};
#define ARITHTEXTBOX 1

int do_aritherrorhelp(){

         aritherrorhelp_dialog[ARITHTEXTBOX].dp=curstatestring;

         popup_dialog(aritherrorhelp_dialog,-1);

         return 0;
}
#include <float.h>
int do_interpret(){

   int interpretret=0;

   int alertret;

   deltaanglerad = DEG2RAD(deltaangledeg);
   maxx=0;maxy=0;maxz=0;minx=0;miny=0;minz=0;
   fmaxx=0;fmaxy=0;fmaxz=0;fminx=0;fminy=0;fminz=0;
   umaxx=0;umaxy=0;umaxz=0;uminx=0;uminy=0;uminz=0;
   lmaxx=0;lmaxy=0;lmaxz=0;lminx=0;lminy=0;lminz=0;

   maxlength=10;
   minlength=10;
   maxdrawlength=10;
   mindrawlength=10;

   maxthickness=thick;
   minthickness=thick;
   numobjects=0;

   production_menu[PRODPLAY].flags |= D_DISABLED;
   production_menu[PRODSAVE].flags |= D_DISABLED;
   production_menu[PRODINTERPREMAP].flags |= D_DISABLED;
   dialog1[PROCPLAYBUT].flags |= D_DISABLED;
   dialog1[PROCSAVEMIDIBUT].flags |= D_DISABLED;
   dialog1[PROCREMAPBUT].flags |= D_DISABLED;
   redrawbuttons();

   if(randomize_p)
         rstart = makeseed();
   srand(rstart);
   set_mouse_sprite(waitmouseu);
   showprocessstatus("Finding Interpret Limits");

   interpretret=interpret(0);

   set_mouse_sprite(NULL);
   showprocessstatus("");
   if( interpretret <= INTERPRETARITHERROR){
        alertret=alert3("Arithmetic error while interpreting.","Have to quit.",NULL,"OK","Rats!","Help",13,0,'h');
        if(alertret==3)
                       do_aritherrorhelp();
        if(interpretret==INTERPRETARITHERROR){
        /* with signal set in interpret(), we should never get in here*/
#ifdef EXITONARITHERROR
              allegro_exit();
              print_curstate();
              exit(0);
#endif
        }
        _clear87();/*???*/
        return D_O_K;
   }
   else if(interpretret==INTERPRETFILEERROR){
        production_menu[PRODINTERP].flags |= D_DISABLED;
        production_menu[PRODREMAKE].flags |= D_DISABLED;
        dialog1[PROCINTERPBUT].flags |= D_DISABLED;
        dialog1[PROCREMAKEBUT].flags |= D_DISABLED;
        alert("Production file error","","... Quitting","OK",NULL,13,0);
        return D_O_K;
   }
   else if(interpretret==INTERPRETABORT){
        alert("Interpret aborted","(too soon to have anything to play)",NULL,"OK",NULL,13,0);
        return D_O_K;
   }
   else if(interpretret==INTERPRETSTACKOVERFLOW){
        alert("Interpret failed","Stack full!","","OK","What the hell?",13,0);
        return D_O_K;
   }
   else if(interpretret==INTERPRETSTACKUNDERFLOW){
        alert("Interpret failed","Pop from empty stack","","OK","What the hell?",13,0);
        return D_O_K;
   }

   if( numobjects == 0){
        alert("No objects. Done.",NULL,NULL,"OK",NULL,13,0);
        return D_O_K;
   }

   production_menu[PRODINTERPREMAP].flags &= ~D_DISABLED;
   dialog1[PROCREMAPBUT].flags &= ~D_DISABLED;
   redrawbuttons();
   return do_interpretremap();
}


int do_interpretremap(){
   int i;
   int obj;

   int playonabort;
   int interpretret;
   int alertret;
   int connectret;

   connectret=do_mconnect_dialog(0);
   if(connectret==-1)
         return D_O_K;

   if(getdrawinglimits()<0){
        alert("Object has 0 size",NULL,NULL,"OK",NULL,13,0);
        return D_O_K;
   }
   production_menu[PRODPLAY].flags |=  D_DISABLED;
   production_menu[PRODSAVE].flags |=  D_DISABLED;
   dialog1[PROCPLAYBUT].flags |= D_DISABLED;
   dialog1[PROCSAVEMIDIBUT].flags |= D_DISABLED;
   redrawbuttons();

   for(i=0;i<MAXTRACKS;i++){
                  free_midi_note_list( tracklist[i] );
                  tracklist[i]=NULL;
   }
   if(draw_p){
     show_mouse(NULL);

     dialog_message(&dialog1[DRAWBOX],MSG_DRAW,0,&obj);
     dialog_message(&dialog1[DIALOG1RULES], MSG_DRAW, 0,&obj);
     show_mouse(NULL);
     rectfill(screen,drawleftx-4,drawbottomy+4,drawrightx+4,drawtopy-4,19);
     rectfill(screen,drawleftx-2,drawbottomy+2,drawrightx+2,drawtopy-2,DRAWBG);

     show_mouse(screen);
   }
   deltaanglerad = DEG2RAD(deltaangledeg);
   srand(rstart);
   set_mouse_sprite(waitmouset);
   showprocessstatus("Interpreting");

   interpretret=interpret(1);

   set_mouse_sprite(NULL);
   showprocessstatus("");
   if(interpretret <= INTERPRETARITHERROR){

      alertret=alert3("Arithmetic error while interpreting.","Have to quit.",NULL,"OK","Rats!","Help",13,0,'h');
      if(alertret==3)
                       do_aritherrorhelp();
      if(interpretret==INTERPRETARITHERROR){
      /* with signal set in interpret(), we should never get in here*/
#ifdef EXITONARITHERROR
         allegro_exit();
         print_curstate();
         exit(0);
#endif
      }
      _clear87();
      return D_O_K;

   }
   else if(interpretret==INTERPRETFILEERROR){

        alert("Production file error","","... Quitting","OK",NULL,13,0);
        return D_O_K;
   }
   else if(interpretret==INTERPRETABORT){
        playonabort=2;
        if(autoplay){
            playonabort=alert("Interpret aborted","Play anyway?","","Yes","No",'y','n');
        }
        production_menu[PRODPLAY].flags &= ~D_DISABLED;
        production_menu[PRODSAVE].flags &= ~D_DISABLED;
        production_menu[PRODINTERP].flags &= ~D_DISABLED;
        production_menu[PRODREMAKE].flags &= ~D_DISABLED;

        dialog1[PROCPLAYBUT].flags &= ~D_DISABLED;
        dialog1[PROCSAVEMIDIBUT].flags &= ~D_DISABLED;
        dialog1[PROCINTERPBUT].flags &= ~D_DISABLED;
        dialog1[PROCREMAKEBUT].flags &= ~D_DISABLED;

        strcpy(playrulefilename,rulefilename);
        redrawbuttons();

        if(playonabort==2) return D_O_K;
   }
   production_menu[PRODPLAY].flags &= ~D_DISABLED;
   production_menu[PRODSAVE].flags &= ~D_DISABLED;
   production_menu[PRODINTERPREMAP].flags &= ~D_DISABLED;
   production_menu[PRODINTERP].flags &= ~D_DISABLED;
   production_menu[PRODREMAKE].flags &= ~D_DISABLED;

   dialog1[PROCPLAYBUT].flags &= ~D_DISABLED;
   dialog1[PROCSAVEMIDIBUT].flags &= ~D_DISABLED;
   dialog1[PROCREMAPBUT].flags &= ~D_DISABLED;
   dialog1[PROCINTERPBUT].flags &= ~D_DISABLED;
   dialog1[PROCREMAKEBUT].flags &= ~D_DISABLED;


   strcpy(playrulefilename,rulefilename);
   if( maxcumtime == 0){
        alert("Total time of piece is 0. Done.",NULL,NULL,"OK",NULL,13,0);
        return D_O_K;
   }
   redrawbuttons();
   if(autoplay)
       return (do_testplay());
   return D_O_K;
}

int turnonsound(){
       char message1[80];
       char message2[80];
       int ret;

       remove_sound();
       ret=install_sound(soundcard, midicard, "");
       if (ret != 0) {

         sprintf(message1,"Error initializing sound system for LMUSe");
         sprintf(message2,"%s", allegro_error);
         alert(message1,message2,NULL,"OK",NULL,13,0);
         soundcard=DIGI_NONE;
         midicard=MIDI_NONE;
         options_menu[SOUNDTOGGLE].flags &= ~D_SELECTED;
         soundoff=1;
      }

      if(!soundoff){
         load_midi_patches();
         options_menu[SOUNDTOGGLE].flags |= D_SELECTED;
      }
      return ret;
}
int do_testplay(){

   do_stopmidifile();
   timertempo(tempo);
#ifdef NOTALWAYSSOUND
   if(!soundoff){ /*"if sound isn't de-selected, turn it on"*/
      turnonsound();
   }
#endif
   centre_dialog(play_dialog);
   popup_dialog(play_dialog,-1);

#ifdef NOTALWAYSSOUND
   if(!soundoff)
      remove_sound(); /*"if sound isn't de-selected, turn it off"*/
#endif

   return D_O_K;
}

DATAFILE * Data1;

void setup_processbuttons();
int readinifile();
int quiet=FALSE;


#if defined(ALLOWSETGFXMODE)
void set_gui_colors()
{
   static RGB black = { 0,  0,  0  };
   static RGB grey  = { 48, 48, 48 };
   static RGB white = { 63, 63, 63 };

   set_color(0, &black);
   set_color(16, &black);
   set_color(1, &grey); 
   set_color(255, &white); 

   gui_fg_color = 255;
   gui_bg_color = 0;
}
#endif


int main(int argc,char *argv[]){

   char *datafilepath=NULL;
   int numargs=argc-1;
   char argvbuf[80];
   char *aptr;
   int recurse;
   int ret;
   int i,n;

   int c;
#if defined(ALLOWSETGFXMODE)
   int setgfxmode=0;
#endif

   init_maps();
   init_trackstuff();
   for(n = 1; n<=numargs;n++) {
        strcpy(argvbuf,argv[n]);
        strupr(argvbuf);
        aptr=argvbuf;
        if (*aptr == '-'){
             aptr++;
             if(*aptr=='S'){
                aptr++;
                maxstringlength = 1024*atoi(aptr);
             }
             /**/
             else if(*aptr=='D'){
                aptr++;
                soundcard = atoi(aptr);
             }
             else if(*aptr=='M'){
                aptr++;
                midicard = atoi(aptr);
             }

             else if(*aptr=='I'){
                aptr++;
                useinifile=1;
                if(*aptr)
                   strcpy(inifile,aptr);
             }
             else if(*aptr=='Q'){
                aptr++;
                quiet=TRUE;
                soundcard=DIGI_NONE;
                midicard=MIDI_NONE;

             }
#if defined(ALLOWSETGFXMODE)
             else if(*aptr=='G'){
                aptr++;
                c=atoi(aptr);
                if(c==0)
                   setgfxmode=1;
                else{
                   switch(c){
                       case 1:
                          videow=640; videoh=480;
                          break;
                       case 2:
                          videow=800; videoh=600;
                          break;
                       case 3:
                          videow=1024; videoh=768;
                          break;
                       case 4:
                          videow=1280; videoh=1024;
                          break;
                       case 5:
                          videow=1600; videoh=1200;
                          break;
                       default:
                          setgfxmode=1;
                   }
                }

             }
#endif
        }
   
   }
   if(useinifile)
         readinifile();
   readconfigfile();
   allegro_init();
   install_keyboard();
   install_mouse();
   install_timer();

   LOCK_VARIABLE(int_t1);
   LOCK_FUNCTION(t_int1);

   LOCK_FUNCTION(arithmeticerrorhandler);

   randomize();
   rstart = makeseed();
   lastseed=rstart;
   initrules();

   Mf_error=allegroexiterror;

   vw = XY;

   recurse = -1;

#if defined(ALLOWSETGFXMODE)
   if(setgfxmode){
       set_gui_colors();
       if(set_gfx_mode(GFX_AUTODETECT, 640,480, 0, 0)!=0){
             allegro_exit();
             printf("Error initializing graphics for LMUSe\n%s\n",allegro_error);
             exit(1);
    
       }
       if (!Lgfx_mode_select(&videocard, &videow, &videoh)) {
             allegro_exit();
             exit(1);
       }
       if(videow<640||videoh<480){
             allegro_exit();
             printf("\nLMUSe screen dimensions need to be at least 640x480\n");
             exit(1);
    
       }
   }

#endif
   if(set_gfx_mode(videocard, videow ,videoh, 0, 0)!=0){

         allegro_exit();
         printf("Error initializing graphics for LMUSe\n%s\n",allegro_error);
         exit(1);

   }
   centre_dialog(dialog1);
   datafilepath = getenv("LMUSDATA");
   if (datafilepath == NULL) datafilepath = "lmus.dat";
   Data1=load_datafile(datafilepath);
   if(Data1 !=NULL){
            set_palette(Data1[PAL1].dat);

            rectfill(screen,dialog1[0].x, dialog1[0].y, dialog1[0].x+dialog1[0].w,dialog1[0].y+dialog1[0].h, EMPTYBG);

            maxcolor=255;
            waitmouseb=Data1[WAITMOUSEB].dat;
            waitmousep=Data1[WAITMOUSEP].dat;
            waitmouset=Data1[WAITMOUSET].dat;
            waitmouseu=Data1[WAITMOUSEU].dat;
            pointup=Data1[POINTUP].dat;
            lmtitle=Data1[LMTITLE].dat;
            font=Data1[THEFONT].dat;
            setup_processbuttons();
   }
   else {

      allegro_exit();
      printf("\nLMUSe couldn't load the data file LMUS.DAT.\n");
      printf("Check that LMUS.DAT exists, and that you are either\n");
      printf("running LMUSe from the same directory that LMUS.DAT is in,\n");
      printf("or that the environmental variable LMUSDATA is set to\n");
      printf("the location of LMUS.DAT. \ne.g.\n\tSET LMUSDATA=C:\\LMUSE\\LMUS.DAT\n");

      exit(1);
   }

   if(!soundoff){
       turnonsound();
#ifdef NOTALWAYSSOUND
       /* sound works ok, now turn it off till we need it*/
       remove_sound();
#endif
   }
   if (midicard==MIDI_NONE){
        options_menu[SOUNDTOGGLE].flags &= ~D_SELECTED;
        soundoff=1;
   }
   else{
        options_menu[SOUNDTOGGLE].flags |= D_SELECTED;
        soundoff=0;
   }
   if(draw_p)
      options_menu[DRAWTOGGLE].flags |= D_SELECTED;

   if(autoplay)
      options_menu[AUTOPLAYTOGGLE].flags |= D_SELECTED;
   else
      options_menu[AUTOPLAYTOGGLE].flags &= ~D_SELECTED;

   set_mouse_speed(1, 1);

   sprintf(introinfo1,"version %s, %s",PROGRAMVERSION,VERSIONDATE);
   intro_dialog[INTROLOGOBMP].dp=lmtitle;
   centre_dialog(intro_dialog);
   position_mouse(intro_dialog[INTROOKBUTTON].x+intro_dialog[INTROOKBUTTON].w/2,intro_dialog[INTROOKBUTTON].y+intro_dialog[INTROOKBUTTON].h/2);
   ret=do_dialog(intro_dialog,-1);


   ret=do_dialog(dialog1,-1);

   for(i=0;i<MAXTRACKS;i++)
           free_midi_note_list( tracklist[i] );
   set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
   exit(0);
}

int soundtoggle(){

   if(!soundoff){

       options_menu[SOUNDTOGGLE].flags &= ~D_SELECTED;

       remove_sound();

       soundoff=1;

   }
   else{

       if(midicard==MIDI_NONE)
           midicard=MIDI_AUTODETECT;
       if(soundcard==DIGI_NONE)
           soundcard=DIGI_AUTODETECT;

       options_menu[SOUNDTOGGLE].flags |= D_SELECTED;

       if(turnonsound()!=0){
          options_menu[SOUNDTOGGLE].flags &= ~D_SELECTED;

          return D_O_K;
       }
#ifdef NOTALWAYSSOUND
       remove_sound();
#endif

       soundoff=0;
   }
   return D_O_K;
}

int drawtoggle(){
   if (draw_p){
       options_menu[DRAWTOGGLE].flags &= ~D_SELECTED;
       draw_p=0;
   }
   else{
       options_menu[DRAWTOGGLE].flags |= D_SELECTED;
       draw_p=1;
   }
   return D_O_K;
}
int autoplaytoggle(){
   if(autoplay){
       options_menu[AUTOPLAYTOGGLE].flags &= ~D_SELECTED;
       autoplay=0;
   }
   else{
       options_menu[AUTOPLAYTOGGLE].flags |= D_SELECTED;
       autoplay=1;
   }
   return D_O_K;
}

int quitting=0;
int quitter()
{
   int ret;
   quitting=1;
   if(unsavedrulechanges || unsavedmapchanges){
       ret=alert3("Really want to quit?",NULL,"(Changes not saved)", "Yes, quit","Save, then quit","Cancel",'y','s',27);
       if (ret==1){
           return D_CLOSE;
       }
       else if(ret==2){
            if(unsavedrulechanges)
                 saverulesas();
            if(unsavedmapchanges)
                 saveinifile();
            if(quitting)
               return D_CLOSE;
       }

   }
   else {
       ret=alert("Really want to quit?", NULL,NULL, "Yes", "Cancel", 'y', 27);
       if (ret==1)
          return D_CLOSE;
   }
   quitting=0;
   return D_O_K;
}


char * changefileext(char * origfilename,char * newfilename, char * newext){

        char * extptr;
        if(*origfilename&& origfilename !=NULL){
           strcpy (newfilename,origfilename);
           extptr=get_extension(newfilename);
           *extptr='\0'; /*chop off the extension*/
           strcat(newfilename,newext);
           return (newfilename);
        }
        else return (NULL);
}

int writeparameters2miditext(){
        char textbuf1[612];
        char textbuf2[612];
        long sz;

        sprintf (textbuf1,"LMUSe v%s: %s %s: ",PROGRAMVERSION,get_filename(rulefile), originalmutated?"(mutated)":"");

        sprintf(textbuf2,"recursions=%s, angle=%3.2f, Map file: %s ",numrecursestring,deltaangledeg,useinifile ? get_filename(inifile):"default");

        strcat(textbuf1,textbuf2);

        sz=strlen(textbuf1);
        mf_write_meta_event(0L, text_event, textbuf1, sz);

        return 0;
}

int my_writetempotrack(){
      if(writeparameters_p)
            writeparameters2miditext();

      mf_write_tempo((long)mtempo);

      return(1);
}


char prg2channel[255];
char prgsontrack[MAXTRACKS][255];
int counttrackchannels(){
    int tracknumber;
    int i,j,n=0;

    MIDINOTELIST * L,* next_node,* first_node;
    MIDICHANEVENT m;
    unsigned char data1[2];
    char lastprog=-1;
    unsigned char stat;
    unsigned char channel;
    int lastassignedchannel=-1;
    for(i=0;i<MAXTRACKS;i++){
           for(j=0;j<255;j++){
                     prgsontrack[i][j]=0;

           }
    }
    for(j=0;j<255;j++){
            prg2channel[j]=-1;
    }
    for(tracknumber=0;tracknumber<MAXTRACKS;tracknumber++){
        if(trackflags[tracknumber]&ACTIVE){
             if(tracklist[tracknumber]==NULL) continue;
             //channel=trackchannel[whichtrack];
             L=tracklist[tracknumber];
             first_node=L;
             next_node=L->next;
             lastprog=-1;
             while( L!=NULL){
                    m=L->m;
                    stat=m.status&0xF0;
                    channel=m.status&0x0F;
                    data1[0]=m.data1;
                    if(stat==PRG_CHG){

                       lastprog=data1[0];
                       prgsontrack[tracknumber][(int)lastprog]=1;
                       if(prg2channel[(int)lastprog]==-1){
                          if(channel!=9){
                              lastassignedchannel++;
                              if(lastassignedchannel>=9)lastassignedchannel++;
                              lastassignedchannel%=MAXTRACKS;
                              prg2channel[(int)lastprog]=lastassignedchannel;
                          }

                       }
                    }
                    else if(stat==NOTEON){
                       if(lastprog==-1){
                           prgsontrack[tracknumber][0]=1;
                           lastprog=0;
                           if(prg2channel[(int)lastprog]==-1){
                             if(channel!=9){
                                lastassignedchannel++;
                                if(lastassignedchannel>=9)lastassignedchannel++;
                                lastassignedchannel%=MAXTRACKS;
                                prg2channel[(int)lastprog]=lastassignedchannel;
                             }


                           }
                       }
                    }

     
                    L=L->next;

             }


        }

    }
    for(i=0;i<MAXTRACKS;i++){
           for(j=0;j<255;j++){
                     if(prgsontrack[i][j])
                        n++;
           }
    }
    return n;
}

int writesplittracklist (int whichtrack)
{
    int loops;
    MIDINOTELIST * L,* next_node,* first_node;
    MIDICHANEVENT m;
    int i,j,n,tracknumber;
    int notesstillon[127];
    int usingmyprog=1;
    unsigned char stat;
    unsigned char channel;
    unsigned char data1[2];
    unsigned char myprog=0;
    unsigned char lastprog=-1;
    long t,cum_time,holdt=0;


        for(i=0;i<127;i++)
             notesstillon[i]=0;
        whichtrack=whichtrack-1;

        n=0;
        for(tracknumber=0;tracknumber<MAXTRACKS;tracknumber++){

             for(j=0;j<255;j++){
                  if(prgsontrack[tracknumber][j]){
                      if(n==whichtrack){
                        myprog=j;
                        break;
                      }
                      else n++;
                  }
             }
             if(n>=whichtrack&&j<255) break;

        }
        n=0;
        cum_time=0L;
        holdt=0L; t=0L;
        data1[0]=myprog;
        channel=trackchannel[tracknumber];
        lastprog=myprog;
        if(channel!=9)
           channel=prg2channel[myprog];
        mf_write_midi_event(t+holdt,PRG_CHG,channel,data1 ,1L);


    for(loops=0;loops<numloopstosave;loops++){
        L=tracklist[tracknumber];
        first_node=L;
        next_node=L->next;
        while( L!=NULL){

               m=L->m;
               t=m.t;
               stat=m.status&0xF0;
               //channel=m.status&0x0F;
               data1[0]=m.data1;
               data1[1]=m.data2;
               if(stat==PRG_CHG){ /*we made lots of extra prg_chg events*/

                     if(data1[0]==myprog){
                         usingmyprog=1;
                         holdt+=t;
                     }
                     else{
                         usingmyprog=0;
                         holdt+=t;
                     }
                     lastprog=data1[0];

               }
               else if(stat==NOTEON){
                  if(usingmyprog){
                      mf_write_midi_event(t+holdt, stat, channel, data1, 2L);
                      notesstillon[data1[0]]++;
                      holdt=0L;
                  }
                  else holdt+=t;
               }
               else if(stat==NOTEOFF){
                  if(notesstillon[data1[0]]){
                      mf_write_midi_event(t+holdt, stat, channel, data1, 2L);
                      notesstillon[data1[0]]--;
                      holdt=0L;
                  }
                  else holdt+=t;
               }
               else holdt+=t; /*some event we are not saving */

               L=L->next;
               n++;
    }
	}
	return n;
}/*end writesplittracklist()*/

int writetracklist (int whichtrack) /* whichtrack refers to the tracknumber
                                       in the MIDI file, not the LMUSe track*/
{
        int loops;
        MIDINOTELIST * L,* next_node,* first_node;
        MIDICHANEVENT m;
        int n,tracknumber;
        unsigned char stat;
        unsigned char channel;
	unsigned char data1[2]/*,data2[2]*/;
	long t,cum_time,holdt=0;
	unsigned char lastprog=-1;

        whichtrack=whichtrack-1;
        n=0;
        for(tracknumber=0;tracknumber<MAXTRACKS;tracknumber++){
             if(trackflags[tracknumber]&ACTIVE){
                  if(n==whichtrack){
                        whichtrack=tracknumber;
                        break;
                  }
                  else n++;
             }

        }
        channel=trackchannel[whichtrack];
        n=0;
        cum_time=0L;
        holdt=0L;
     for(loops=0;loops<numloopstosave;loops++){   
        L=tracklist[whichtrack];
        first_node=L;
        next_node=L->next;
	while( L!=NULL){

               m=L->m;
               t=m.t;
               stat=m.status&0xF0;

               data1[0]=m.data1;
               data1[1]=m.data2;
               if(stat==PRG_CHG){ /*we made lots of extra prg_chg events*/
                     if(lastprog!=data1[0]){
                         mf_write_midi_event(t+holdt,stat,channel,data1 ,1L);
                         lastprog=data1[0];
                         holdt=0L;
                     }
                     else holdt+=t;
               }
               else if(stat==NOTEON||stat==NOTEOFF){
                  mf_write_midi_event(t+holdt, stat, channel, data1, 2L);
                  holdt=0L;
               }
               else holdt+=t; /*some event we are not saving */

               L=L->next;
               n++;
	}
     }
	return n;
}/*end writetracklist()*/


int saveproduction(){
        int dret=do_savefiledialog("Save production as:",productionfile,"out");
        FILE *prod_fp;
        if(dret>0){
              if((prod_fp = fopen(productionfile,"w")) == 0L)
                  alert("Unable to open file for writing.",NULL,NULL,"OK",NULL,13,0);
              else{
                   fputs(production,prod_fp);
                   fclose(prod_fp);
              }
        }
        return D_O_K;
}

int saveproduction_proc(int msg, DIALOG *d, int c){
    int sret;
    int ret=d_button_proc(msg, d, c);
    if(ret==D_CLOSE){
           sret=saveproduction();
           return D_O_K;
    }
    return(ret);
}
int savemidi_proc(int msg, DIALOG *d, int c){
        int ret=d_button_proc(msg, d, c);

        if(ret==D_CLOSE){
           ret=do_midisave();
        }
        return(ret);
}

int savemidi(char *midifilename){
    int tracknumber;
    int numtracks=0;
    for(tracknumber=0;tracknumber<MAXTRACKS;tracknumber++){
               if(trackflags[tracknumber]&ACTIVE)
                      numtracks++;
    }
    if((savemf_fp = fopen(midifilename,"wb")) == 0L){
         alert("Unable to open file for writing.",NULL,NULL,"OK",NULL,13,0);
         return -1;
    }
    else{
         Mf_putc = myputc;
         if(splittracksbyprogram){
             numtracks=counttrackchannels();
             Mf_writetrack=writesplittracklist;
         }
         else
             Mf_writetrack=writetracklist;
         Mf_writetempotrack=WriteTempoTrack;
         mfwrite(1,numtracks+1,division,savemf_fp);

         fclose(savemf_fp);
    }
    return 0;
}

int do_midisave(){

        int tracknumber;
        int dret;
        long holdt1=int_t1;

        for(tracknumber=0;tracknumber<MAXTRACKS;tracknumber++){
               all_notes_off(trackchannel[tracknumber]);
        }
        dret=do_savefiledialog("Save MIDI file as:", savemidifile,"mid");
        if(dret>0){
              savemidi(savemidifile);
        }
        int_t1=holdt1;

        return(D_O_K);
}

int do_dosshell(){

   BITMAP * holdscreen;

   holdscreen=create_bitmap(SCREEN_W,SCREEN_H);
   if(holdscreen!=NULL){
          show_mouse(NULL);
          clear(holdscreen);
          blit(screen,holdscreen,0,0,0,0,SCREEN_W-1,SCREEN_H-1);
          show_mouse(screen);
   }
   allegro_exit();

   system("command");
   allegro_init();
   install_keyboard();
   install_mouse();
   install_timer();

   set_gfx_mode(videocard, videow ,videoh, 0, 0);
   if(Data1 !=NULL){
      set_palette(Data1[PAL1].dat);
   }
   else
      set_palette(desktop_palette);

   if(holdscreen!=NULL){
       blit(holdscreen,screen,0,0,0,0,SCREEN_W-1,SCREEN_H-1);
       destroy_bitmap(holdscreen);
   }
   else{
       clear(screen);

       rectfill(screen,0,0,SCREEN_W,SCREEN_H,BG1);
   }

   if(!soundoff){
       turnonsound();
#ifdef NOTALWAYSSOUND
       remove_sound();
#endif
   }
   show_mouse(screen);
   set_mouse_speed(1, 1);
   return D_O_K;
}

int do_edit(char *filename){
   BITMAP * holdscreen;
   char commandbuf[200];
   if(!exists(editorpath)){

        geteditor();
        if(!exists(editorpath))
            return -1;
   }
   sprintf(commandbuf,"%s ",editorpath);
   if( *(get_filename(filename)) != '\0' ){
       strcat(commandbuf,filename);
   }

   holdscreen=create_bitmap(SCREEN_W,SCREEN_H);
   if(holdscreen!=NULL){
          show_mouse(NULL);
          clear(holdscreen);
          blit(screen,holdscreen,0,0,0,0,SCREEN_W-1,SCREEN_H-1);
          show_mouse(screen);
   }
   
   allegro_exit();

   system(commandbuf);

   allegro_init();
   install_keyboard();
   install_mouse();
   install_timer();

   set_gfx_mode(videocard, videow ,videoh, 0, 0);
   if(Data1 !=NULL){
      set_palette(Data1[PAL1].dat);
   }
   else
      set_palette(desktop_palette);

   if(holdscreen!=NULL){
       blit(holdscreen,screen,0,0,0,0,SCREEN_W-1,SCREEN_H-1);
       destroy_bitmap(holdscreen);
   }
   else{
       clear(screen);

       rectfill(screen,0,0,SCREEN_W,SCREEN_H,BG1);
   }

   if(!soundoff){
       turnonsound();
#ifdef NOTALWAYSSOUND
       remove_sound();
#endif
   }
   show_mouse(screen);
   set_mouse_speed(1, 1);

   return 0;
}
int editrulefile(){
     int ret,makeret;
     int obj;
     char buf1[120];

     if(do_edit(rulefile)==-1) return D_O_K;
     if(*(get_filename(rulefile))!='\0'){
         sprintf(buf1,"Reload %s",get_filename(rulefile));
         ret=alert3(NULL,NULL,NULL,buf1,"Cancel","New Rule File",13,0,'n');
     }
     else{
        ret=alert(NULL,NULL,NULL,"Load Rule File","Cancel",13,0);
        if (ret==1) ret=3;
     }
     if(ret==2) return D_O_K;

     production_menu[PRODPLAY].flags |= D_DISABLED;
     production_menu[PRODSAVE].flags |= D_DISABLED;
     production_menu[PRODINTERPREMAP].flags |= D_DISABLED;
     production_menu[PRODINTERP].flags |= D_DISABLED;
     production_menu[PRODREMAKE].flags |= D_DISABLED;
     production_menu[PRODSAVERULES].flags |= D_DISABLED;

     dialog1[PROCPLAYBUT].flags |= D_DISABLED;
     dialog1[PROCSAVEMIDIBUT].flags |= D_DISABLED;
     dialog1[PROCREMAPBUT].flags |= D_DISABLED;
     dialog1[PROCINTERPBUT].flags |= D_DISABLED;
     dialog1[PROCREMAKEBUT].flags |= D_DISABLED;
     dialog1[PROCSAVERULESBUT].flags |= D_DISABLED;

     if(ret==1 && *rulefile!='\0' && rulefile!=NULL){
        if(getrules(rulefile)==-1){
                   return D_O_K;
        }
        dialog1[DIALOG1RULES].bg=UNCHANGEDBG;
        dialog_message(&dialog1[DIALOG1RULES], MSG_DRAW, 0,&obj);
        makeret=do_remakeandinterpret();
     }
     else makeret=do_makeandinterpret();
     return makeret;
}
int savetemprulefile();
char temprulesname[120]="LMUSEDIT.TMP";
int editrules(){
     int ret,saveret,makeret;
     int obj;
     int maxlevel;

     saveret=savetemprulefile();
     if(saveret==-1) return D_O_K;

     if(do_edit(temprulesname)==-1) return D_O_K;

     ret=alert(NULL,NULL,NULL,"Use Edited Rules","Discard Changes",13,0);
     if(ret==2) return D_O_K;

     production_menu[PRODPLAY].flags |= D_DISABLED;
     production_menu[PRODSAVE].flags |= D_DISABLED;
     production_menu[PRODINTERPREMAP].flags |= D_DISABLED;
     production_menu[PRODINTERP].flags |= D_DISABLED;

     dialog1[PROCPLAYBUT].flags |= D_DISABLED;
     dialog1[PROCSAVEMIDIBUT].flags |= D_DISABLED;
     dialog1[PROCREMAPBUT].flags |= D_DISABLED;
     dialog1[PROCINTERPBUT].flags |= D_DISABLED;

     initrules();
     rulefilefp=fopen(temprulesname,"r");
     if(rulefilefp==NULL){
          alert("file error","","","OK",NULL,13,0);
          return D_O_K;
     }

     maxlevel=readrulefile(rulefilefp);
     unsavedrulechanges=1;
     sprintf(numrecursestring,"%d",maxlevel);
     sprintf(deltaanglestring,"%3.2f",deltaangledeg);
     sprintf(thickstring,"%3.2f",thick);
     sprintf(numrulesstring,"transformation rules (%d):",numrules);
     fclose(rulefilefp);

     dialog1[DIALOG1RULES].bg=CHANGEDBG;
     dialog_message(&dialog1[DIALOG1RULES], MSG_DRAW, 0,&obj);

     makeret=do_remakeandinterpret();
     return makeret;
}



int geteditor(){
     int fsret=1,alertret;
     char buf[100];
     char editorbuf[120];
     strcpy(editorbuf,editorpath);

     while (fsret){
          fsret=popup_file_select("Use DOS editor:", editorbuf, "exe;com;bat");
          if(fsret==0) return 0;
          if(!exists(editorbuf)){
               sprintf(buf, "Can't find %s", editorbuf);
               alertret=alert3(buf, NULL, NULL, "OK", "Try again","Cancel", 13,'t', 27) ;
               if(alertret==1) return 0;
               else if (alertret == 3)
                  return D_O_K;
               else if(alertret==2){
                  fsret=1;
               }
          }
          else fsret=0;
     }
     strcpy (editorpath,editorbuf);
     writeconfigfile();
     return D_O_K;
}



int loadini_proc(int msg,DIALOG *d, int c __attribute__ ((unused))){
    int ret;

    ret= getinibutton_proc(msg,d,255);

    return ret;
}
int saveini_proc(int msg,DIALOG *d, int c){
    int butret=d_button_proc(msg,d,c);
    if(butret==D_CLOSE){
         saveinifile();
         return D_O_K;
    }
    return butret;
}
int writeallmaps=1;
int saveonemap_proc(int msg,DIALOG *d, int c){
    int butret=d_button_proc(msg,d,c);
    if(butret==D_CLOSE){
         writeallmaps=0;
         saveinifile();
         writeallmaps=1;
         return D_O_K;
    }
    return butret;
}

int saveinifile(){

        char saveininame[256];
        int mapnumber=writeallmaps?-1:cureditmap;
        int dret;

        strcpy(saveininame,inifile);
        dret=do_savefiledialog("Save map as:",saveininame,"ini;map");

        if(dret>0){
              strcpy(inifile,saveininame);
              do_mconnect_dialog(cureditmap);
              if(writeinifile(mapnumber)==-1)
                  alert("Unable to open file for writing.",NULL,NULL,"OK",NULL,13,0);
              useinifile=1;
        }
        else if(quitting) quitting=0;
        return D_O_K;
}


char configfile[256]="lmuse.cfg";
int readconfigfile(){
    FILE *fp;
    char *configfilepath=NULL;
    configfilepath = getenv("LMUSCFG");
    if (configfilepath == NULL)
         configfilepath = configfile;

    fp=fopen(configfilepath,"r");
    if(fp==NULL) return -1;
    fgets(editorpath,119,fp);
    fclose(fp);
    return 0;
}

int writeconfigfile(){
    FILE *fp;
    fp=fopen(configfile,"w");
    if(fp==NULL) return -1;
    fputs(editorpath,fp);
    fclose(fp);
    return 0;

}

#define MUTATESUCCESS 1
#define MUTATEFAILED -1
#define NOMUTATION 0
#define MAXMUTATEATTEMPTS 100
int mutaterules(){
        int mutateret,obj;
        int numattempts=0;
        while( (mutateret=L_mutate())==NOMUTATION && numattempts<MAXMUTATEATTEMPTS){
              numattempts++;
        }
        if(mutateret!=MUTATEFAILED)
            mutate_menu[MUTATESAVE].flags &= ~D_DISABLED;
        if(mutateret>0){
             originalmutated=1;
             unsavedrulechanges=1;
             dialog1[DIALOG1RULES].bg=MUTATEDBG;
             dialog_message(&dialog1[DIALOG1RULES], MSG_DRAW, 0,&obj);
        }
        return D_O_K;
}

int mutateandremake(){
        mutaterules();
        return do_remakeandinterpret();
}

FILE * mutatedfp;

int savemutation(){
        int i;
        time_t now;
        int dret=do_savefiledialog("Save mutated rules as:",mutationfile,"l;ls;lm");

        if(dret>0){
              if((mutatedfp = fopen(mutationfile,"w")) == 0L)
                  alert("Unable to open file for writing.",NULL,NULL,"OK",NULL,13,0);
              else{
                   time(&now);
                   fprintf(mutatedfp,"# LMUSe Mutation %s\n# %s", get_filename(mutationfile),asctime(localtime(&now)));
                   fprintf(mutatedfp,"# Current rulefile: %s\n",*rulefile?get_filename(rulefile):"(none)");

                   fprintf(mutatedfp,"%s\n",numrecursestring);
                   fprintf(mutatedfp,"%f\n",deltaangledeg);
                   fprintf(mutatedfp,"%f\n",thick);
                   fprintf(mutatedfp,"%s\n",axiom);

                   for (i = 0; i < MAXRULES; i++) {
                       if (rules[i] == NULL)
                       break;
                       fprintf(mutatedfp,"%s\n",rules[i]);
                   }
                   fprintf(mutatedfp,"%c",'@');
                   fclose(mutatedfp);
                   unsavedrulechanges=0;
              }

        }
        return D_O_K;
}

int saverulesas(){
        FILE *fp;
        char saverulesname[256];
        int i,obj;
        int dret;
        time_t now;

        strcpy(saverulesname,rulefile);
        dret=do_savefiledialog("Save rules as:",saverulesname,"l;ls;lm");

        if(dret>0){
              if((fp = fopen(saverulesname,"w")) == 0L)
                  alert("Unable to open file for writing.",NULL,NULL,"OK",NULL,13,0);
              else{
                   time(&now);
                   fprintf(fp,"# %s\n",get_filename(saverulesname));
                   fprintf(fp,"# %s", asctime(localtime(&now)));

                   fprintf(fp,"%s\t# recursion level\n",numrecursestring);
                   fprintf(fp,"%3.3f\t# angle\n",deltaangledeg);
                   fprintf(fp,"%3.3f\t# thickness\n",thick);
                   fprintf(fp,"# axiom:\n%s\n",axiom);

                   for (i = 0; i < MAXRULES; i++) {
                       if (rules[i] == NULL)
                       break;
                       fprintf(fp,"%s\n",rules[i]);
                   }
                   fprintf(fp,"%c  # end",'@');
                   fclose(fp);

                   strcpy(rulefile,saverulesname);
                   strcpy(rulefilename,get_filename(rulefile));
                   changefileext(rulefile,productionfile,"out");
                   changefileext(rulefile,savemidifile,"mid");
                   changefileext(rulefile,mutationfile,"lm");
                   changefileext(get_filename(rulefile),productionfilename,"");
                   dialog1[DIALOG1RULES].bg=UNCHANGEDBG;
                   dialog_message(&dialog1[DIALOG1RULES], MSG_DRAW, 0,&obj);

                   unsavedrulechanges=0;
              }
   
        }
        else if (quitting) quitting=0;
        return D_O_K;
}


int savetemprulefile(){
        FILE *fp;
        time_t now;
        int i;

        if((fp = fopen(temprulesname,"w")) == 0L){
                  alert("Unable to open temporary file for writing.",NULL,NULL,"OK",NULL,13,0);
                  return -1;
        }
        else{
             time(&now);
             fprintf(fp,"# LMUSe temporary file. Transformation rules currently in LMUSe's memory\n# %s", asctime(localtime(&now)));
             fprintf(fp,"# Current rulefile: %s\n",*rulefile?get_filename(rulefile):"(none)");

             fprintf(fp,"%s\t# number of recursions\n",numrecursestring);
             fprintf(fp,"%3.3f\t# angle\n",deltaangledeg);
             fprintf(fp,"%3.3f\t# thickness\n",thick);
             fprintf(fp,"# axiom:\n%s\n",axiom);
             fprintf(fp,"# Transformation rules:\n");
             for (i = 0; i < MAXRULES; i++) {
                       if (rules[i] == NULL)
                       break;
                       fprintf(fp,"%s\n",rules[i]);
             }
             fprintf(fp,"%c\t# end",'@');
             fclose(fp);
        }
        return 0;
}

FILE *playmidifile_fp;
char playmidifilename[256];
MIDI * midifilemidi=NULL;
int do_getmidifiledialog(){
     int fsret=1,alertret;
     char buf[100];
     while (fsret){
          fsret=popup_file_select("MIDI File to play:", playmidifilename, "mid");
          if(fsret==0) return 0;
          if(!exists(playmidifilename)){
               sprintf(buf, "Can't find %s", playmidifilename);
               alertret=alert3(buf, NULL, NULL, "OK", "Try again","Cancel", 13,'t', 27) ;
               if(alertret==1) return 0;
               else if (alertret == 3)
                  return 0;
               else if(alertret==2){
                  fsret=1;
               }
          }
          else fsret=0;
     }

     return(1);
}

int do_playmidifile(){

#ifdef NOTALWAYSSOUND
   char message1[80];
   char message2[80];
   if(!soundoff){
      if(turnonsound()!=0)
          return D_O_K;
   }
#endif
   if(soundoff) {
        alert("Sound is turned off",NULL,NULL,"OK",NULL,13,0);
        return D_O_K;
   }

   if(do_getmidifiledialog()==0){

       return D_O_K;
   }
   midifilemidi=load_midi(playmidifilename);
   if(midifilemidi!=NULL){
      play_midi(midifilemidi,0);
      production_menu[PRODSTOPPLAY].flags&=~D_DISABLED;
   }

   return D_O_K;
}

int do_stopmidifile(){

   if(midifilemidi){
      stop_midi(NULL,0);
      production_menu[PRODSTOPPLAY].flags|=D_DISABLED;
   }
#ifdef NOTALWAYSSOUND
   if(!soundoff) remove_sound();
#endif
   destroy_midi(midifilemidi);
   midifilemidi=NULL;

   return D_O_K;
}


void setup_processbuttons(){

      dialog1[PROCEDITBUT].dp=Data1[EDITBUT].dat;
      dialog1[PROCEDITBUT].dp2=Data1[EDITSEL].dat;
      dialog1[PROCEDITBUT].dp3=Data1[EDITDIS].dat;

      dialog1[PROCEDITRULESBUT].dp=Data1[RULEEDITBUT].dat;
      dialog1[PROCEDITRULESBUT].dp2=Data1[RULEEDITSEL].dat;
      dialog1[PROCEDITRULESBUT].dp3=Data1[RULEEDITDIS].dat;

      dialog1[PROCLOADBUT].dp=Data1[LOADBUT].dat;
      dialog1[PROCLOADBUT].dp2=Data1[LOADSEL].dat;
      dialog1[PROCLOADBUT].dp3=Data1[LOADDIS].dat;
      
      dialog1[PROCMAKEBUT].dp=Data1[MAKEBUT].dat;
      dialog1[PROCMAKEBUT].dp2=Data1[MAKESEL].dat;
      dialog1[PROCMAKEBUT].dp3=Data1[MAKEDIS].dat;

      dialog1[PROCMAKEANDBUT].dp=Data1[MAKEANDBUT].dat;
      dialog1[PROCMAKEANDBUT].dp2=Data1[MAKEANDSEL].dat;
      dialog1[PROCMAKEANDBUT].dp3=Data1[MAKEANDDIS].dat;

      dialog1[PROCMUTATEBUT].dp=Data1[MUTATEBUT].dat;
      dialog1[PROCMUTATEBUT].dp2=Data1[MUTATESEL].dat;
      dialog1[PROCMUTATEBUT].dp3=Data1[MUTATEDIS].dat;

      dialog1[PROCMUTANDBUT].dp=Data1[MUTANDBUT].dat;
      dialog1[PROCMUTANDBUT].dp2=Data1[MUTANDSEL].dat;
      dialog1[PROCMUTANDBUT].dp3=Data1[MUTANDDIS].dat;

      dialog1[PROCINTERPBUT].dp=Data1[INTERPBUT].dat;
      dialog1[PROCINTERPBUT].dp2=Data1[INTERPSEL].dat;
      dialog1[PROCINTERPBUT].dp3=Data1[INTERPDIS].dat;

      dialog1[PROCPLAYBUT].dp=Data1[PLAYBUT].dat;
      dialog1[PROCPLAYBUT].dp2=Data1[PLAYSEL].dat;
      dialog1[PROCPLAYBUT].dp3=Data1[PLAYDIS].dat;

      dialog1[PROCQUITBUT].dp=Data1[QUITBUT].dat;
      dialog1[PROCQUITBUT].dp2=Data1[QUITSEL].dat;
      dialog1[PROCQUITBUT].dp3=Data1[QUITDIS].dat;

      dialog1[PROCREMAKEBUT].dp=Data1[REMAKEBUT].dat;
      dialog1[PROCREMAKEBUT].dp2=Data1[REMAKESEL].dat;
      dialog1[PROCREMAKEBUT].dp3=Data1[REMAKEDIS].dat;

      dialog1[PROCREMAPBUT].dp=Data1[REMAPBUT].dat;
      dialog1[PROCREMAPBUT].dp2=Data1[REMAPSEL].dat;
      dialog1[PROCREMAPBUT].dp3=Data1[REMAPDIS].dat;

      dialog1[PROCSAVEMIDIBUT].dp=Data1[SAVEMIDIBUT].dat;
      dialog1[PROCSAVEMIDIBUT].dp2=Data1[SAVEMIDISEL].dat;
      dialog1[PROCSAVEMIDIBUT].dp3=Data1[SAVEMIDIDIS].dat;

      dialog1[PROCSAVERULESBUT].dp=Data1[SAVERULESBUT].dat;
      dialog1[PROCSAVERULESBUT].dp2=Data1[SAVERULESSEL].dat;
      dialog1[PROCSAVERULESBUT].dp3=Data1[SAVERULESDIS].dat;

}



