#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "allegro.h"
#include "lmuse.h"

/*extern lmuse.c*/
extern int useinifile;
extern int unsavedmapchanges;
extern char deltaanglestring[];
extern float deltaangledeg;
extern char inifile[];
extern long tempo;
extern unsigned rstart,lastseed;
extern char rulefile[];
extern int originalmutated;
#if defined(SCREENDUMPS)
int dump_screen();
#endif

/*extern prod.c*/
extern char commentchar;
char * formatline(char *line);

/*extern interpret.c*/
extern VARIABLE pitchvariable, durationvariable, velocityvariable;
extern VARIABLE statevariablearray[];
extern VARIABLE constantvar;
extern float maxx,maxy,maxz,minx,miny,minz;
extern float fmaxx,fmaxy,fmaxz,fminx,fminy,fminz;
extern float umaxx,umaxy,umaxz,uminx,uminy,uminz;
extern float lmaxx,lmaxy,lmaxz,lminx,lminy,lminz;
extern float maxlength, minlength;
extern float maxdrawlength, mindrawlength;
extern float maxthickness, minthickness;
extern float dmultiplier, pspread, dspread, vspread;

/*extern scales.c*/
extern char scalenamestring[];
extern char scalefnnamestring[];
extern char * scalenames[];
extern char * scalefnnames[];
extern int numpredefinedscales;
extern SCALE scales[];
extern int (*scalefunctions[])(int,SCALE *);
extern int (*scalefn)(int, SCALE*);
extern char scalestring[];
int scalemenu_proc(int msg, DIALOG*d, int c);
int scalefnmenu_proc(int msg, DIALOG*d, int c);
void scale2scalestring(SCALE* scale);
SCALE * string2scale(char * str);

/*extern help.c*/
int maphelp();
/*extern lfsel.c*/
int popup_file_select(char *message, char *path, char *ext);


MAP maps[MAXMAPS];
int cureditmap=0;
int factstacks_p=0;
int transposestack_p=0;

BITMAP *connect_bmp;

int getinifile();

char transposestring[10];
int d_connect_l_proc(int msg,DIALOG *d, int c);
int d_connect_r_proc(int msg,DIALOG *d, int c);
int d_connect_box_proc(int msg,DIALOG *d,int c);
int dumblit_proc(int msg,DIALOG *d,int c);
int connect_helpbutton_proc(int msg,DIALOG *d, int c);
int getinibutton_proc(int msg,DIALOG *d, int c);

int d_gotomapbutton_proc(int msg,DIALOG *d, int c);
int d_copymapbutton_proc(int msg,DIALOG *d, int c);

#define CONNECT_W 320
#define CONNECT_H 260

#define PCOLOR 1
#define DCOLOR 12
#define VCOLOR 10
char dmultbuf[20];
char pspreadbuf[20];
char dspreadbuf[20];
char vspreadbuf[20];
int setdmult(void *dp3, int d2);
int setpspread(void *dp3, int d2);
int setdspread(void *dp3, int d2);
int setvspread(void *dp3, int d2);
int seelimits_proc(int msg, DIALOG *d, int c);
char mapnumberstring[10]="Map #";
/*   (dialog proc)           (x)   (y)   (w)   (h)       (fg)  (bg)    (key) (flags)  (d1) (d2)   (dp) */
DIALOG connect_dialog[] =
{
   { d_box_proc,              0,0,CONNECT_W,CONNECT_H+156,255,  0,       0,    0,      0,   0,    NULL},
   { d_connect_box_proc,      0,0,CONNECT_W,CONNECT_H,    255,CONNECTBG, 0,    0,      0,   0,    NULL},

   { d_connect_l_proc,        20,   20,   70,    10,      255,  0,       0,    0,      -1,PCOLOR, "pitch"},
   { d_connect_l_proc,        20,   100,   70,    10,      255,  0,       0,    0,      -1,DCOLOR, "duration"},
   { d_connect_l_proc,        20,   180,  70,    10,      255,  0,       0,    0,      -1,VCOLOR, "volume"},

   { d_connect_r_proc,        200,  20,   100,   10,      255,  0,       0,    0,      X_VAR,         0,    "x"},
   { d_connect_r_proc,        200,  35,   100,   10,      255,  0,       0,    0,      Y_VAR,         0,    "y"},
   { d_connect_r_proc,        200,  50,   100,   10,      255,  0,       0,    0,      Z_VAR,         0,    "z"},
   { d_connect_r_proc,        200,  65,   100,   10,      255,  0,       0,    0,      FX_VAR,        0,    "forward x"},
   { d_connect_r_proc,        200,  80,   100,   10,      255,  0,       0,    0,      FY_VAR,        0,    "forward y"},
   { d_connect_r_proc,        200,  95,   100,   10,      255,  0,       0,    0,      FZ_VAR,        0,    "forward z"},
   { d_connect_r_proc,        200,  110,  100,   10,      255,  0,       0,    0,      UX_VAR,        0,    "up x"},
   { d_connect_r_proc,        200,  125,  100,   10,      255,  0,       0,    0,      UY_VAR,        0,    "up y"},
   { d_connect_r_proc,        200,  140,  100,   10,      255,  0,       0,    0,      UZ_VAR,        0,    "up z"},

   { d_connect_r_proc,        200,  155,  100,   10,      255,  0,       0,    0,      LX_VAR,        0,    "left x"},
   { d_connect_r_proc,        200,  170,  100,   10,      255,  0,       0,    0,      LY_VAR,        0,    "left y"},
   { d_connect_r_proc,        200,  185,  100,   10,      255,  0,       0,    0,      LZ_VAR,        0,    "left z"},
   
   { d_connect_r_proc,        200,  200,  100,   10,      255,  0,       0,    0,      LENGTH_VAR,    0,    "state length"},
   { d_connect_r_proc,        200,  215,  100,   10,      255,  0,       0,    0,      DRAWLENGTH_VAR,0,    "draw length"},
   { d_connect_r_proc,        200,  230,  100,   10,      255,  0,       0,    0,      THICKNESS_VAR, 0,    "thickness"},


   { d_text_proc,             160,CONNECT_H+10,0,0,       255,  0,       0,    0,      0,   0,    "Scale:" },
   { scalemenu_proc,          210,CONNECT_H+10,100,10,    255,  0,       0,    0,      0,   0,    scalenamestring},
   { scalefnmenu_proc,        210,CONNECT_H+24,100,10,    255,  0,       0,    0,      0,   0,    scalefnnamestring},

   { d_text_proc,             150,5,           0,  0,     255, CONNECTBG,0,    0,      0,   0,    mapnumberstring},
   { dumblit_proc,            10, 10,          0,  0,CONNECTBG,CONNECTBG,0,    0,      0,   0,    NULL },


   { d_text_proc,             160,CONNECT_H+60, 0,0,      255,  0,       0,    0,      0,   0,    "multiply durations:" },
   { d_slider_proc,           210,CONNECT_H+70,100,10,    255,  0,       0,    0,      400, 0,    NULL,     setdmult},
   { d_edit_proc,             240,CONNECT_H+82,60, 10,    255,  8,       0,    0,      8,   0,    dmultbuf },

   { d_text_proc,             160,CONNECT_H+40, 0,  0,     255,  0,       0,    0,      0,   0,    "Transpose:"},
   { d_edit_proc,             240,CONNECT_H+40, 50, 16,    255,  8,       0 ,   0,      3,   0,    transposestring},

   /*spreads*/
   { d_text_proc,             20,37, 0,0,                 255,  CONNECTBG,       0,    0,      0,   0,    "spread:" },
   { d_slider_proc,           20,50,80,10,                255,  CONNECTBG,       0,    0,      70, 0,    NULL,     setpspread},
   { d_edit_proc,             30,62,60, 10,               255,  0,       0,    0,      8,   0,    pspreadbuf },

   { d_text_proc,             20,117, 0,0,                255,  CONNECTBG,       0,    0,      0,   0,    "spread:" },
   { d_slider_proc,           20,130,80,10,               255,  CONNECTBG,       0,    0,      70, 0,    NULL,     setdspread},
   { d_edit_proc,             30,142,60, 10,              255,  0,       0,    0,      8,   0,    dspreadbuf },

   { d_text_proc,             20,197, 0,0,                255,  CONNECTBG,       0,    0,      0,   0,    "spread:" },
   { d_slider_proc,           20,210,80,10,               255,  CONNECTBG,       0,    0,      70, 0,    NULL,     setvspread},
   { d_edit_proc,             30,222,60, 10,              255,  0,       0,    0,      8,   0,    vspreadbuf },

   { seelimits_proc, CONNECT_W/2-45,CONNECT_H-12,90,12,    255,  0,       0, D_EXIT,  0,   0,    "see limits" },

   { d_text_proc,             10,CONNECT_H+80, 0,  0,     1,  0,       0,    0,      0,   0,    "angle:"},
   { d_edit_proc,             60,CONNECT_H+80, 60, 16,    255,  8,       0 ,   0,      6,   0,    deltaanglestring},


   { d_check_proc,            138,CONNECT_H+100,180,10,     1,  0,       't',    0,      0,   0,    "Use &Transpose stack?"},
   { d_check_proc,            160,CONNECT_H+112,130,10,     1,  0,       'f',    0,      0,   0,    "&Factor stacks?"},

   { d_text_proc,             10,CONNECT_H+10, 0,  0,     255,  0,       0,    0,      0,   0,    "Go to Map #:"},
   { d_gotomapbutton_proc,           10,CONNECT_H+22,10,12,    255,  0,       '0',D_EXIT,    0,   0,    "0" },
   { d_gotomapbutton_proc,           20,CONNECT_H+22,10,12,    255,  0,       '0',D_EXIT,    1,   0,    "1" },
   { d_gotomapbutton_proc,           30,CONNECT_H+22,10,12,    255,  0,       '0',D_EXIT,    2,   0,    "2" },
   { d_gotomapbutton_proc,           40,CONNECT_H+22,10,12,    255,  0,       '0',D_EXIT,    3,   0,    "3" },
   { d_gotomapbutton_proc,           50,CONNECT_H+22,10,12,    255,  0,       '0',D_EXIT,    4,   0,    "4" },
   { d_gotomapbutton_proc,           60,CONNECT_H+22,10,12,    255,  0,       '0',D_EXIT,    5,   0,    "5" },
   { d_gotomapbutton_proc,           70,CONNECT_H+22,10,12,    255,  0,       '0',D_EXIT,    6,   0,    "6" },
   { d_gotomapbutton_proc,           80,CONNECT_H+22,10,12,    255,  0,       '0',D_EXIT,    7,   0,    "7" },
   { d_gotomapbutton_proc,           90,CONNECT_H+22,10,12,    255,  0,       '0',D_EXIT,    8,   0,    "8" },
   { d_gotomapbutton_proc,           100,CONNECT_H+22,10,12,    255,  0,       '0',D_EXIT,    9,   0,    "9" },

   { d_text_proc,             10,CONNECT_H+38, 0,  0,     255,  0,       0,    0,      0,   0,    "Copy Map #:"},
   { d_copymapbutton_proc,           10,CONNECT_H+50,10,12,    255,  0,       '0',D_EXIT,    0,   0,    "0" },
   { d_copymapbutton_proc,           20,CONNECT_H+50,10,12,    255,  0,       '0',D_EXIT,    1,   0,    "1" },
   { d_copymapbutton_proc,           30,CONNECT_H+50,10,12,    255,  0,       '0',D_EXIT,    2,   0,    "2" },
   { d_copymapbutton_proc,           40,CONNECT_H+50,10,12,    255,  0,       '0',D_EXIT,    3,   0,    "3" },
   { d_copymapbutton_proc,           50,CONNECT_H+50,10,12,    255,  0,       '0',D_EXIT,    4,   0,    "4" },
   { d_copymapbutton_proc,           60,CONNECT_H+50,10,12,    255,  0,       '0',D_EXIT,    5,   0,    "5" },
   { d_copymapbutton_proc,           70,CONNECT_H+50,10,12,    255,  0,       '0',D_EXIT,    6,   0,    "6" },
   { d_copymapbutton_proc,           80,CONNECT_H+50,10,12,    255,  0,       '0',D_EXIT,    7,   0,    "7" },
   { d_copymapbutton_proc,           90,CONNECT_H+50,10,12,    255,  0,       '0',D_EXIT,    8,   0,    "8" },
   { d_copymapbutton_proc,           100,CONNECT_H+50,10,12,    255,  0,       '0',D_EXIT,    9,   0,    "9" },

   { d_button_proc,           80,CONNECT_H+128,60,24,    255,  0,       13,D_EXIT,    0,   0,    "Done" },
   { d_button_proc,           150,CONNECT_H+128,60,24,    255,  0,       27,D_EXIT,    0,   0,    "Cancel" },
   { connect_helpbutton_proc, 270,CONNECT_H+128,40,18,    255,  0,      'h',D_EXIT,    0,   0,    "&Help" },

   { getinibutton_proc,       10, CONNECT_H+100,120,18,    255,  0,      'm',D_EXIT,    0,   0,    "Load a &Map" },

#if defined (SCREENDUMPS)
   {d_keyboard_proc,          0,    0,          0, 0,     0,    0,   'd'-'a'+1,   0,       0,   0,    dump_screen},
#endif

   { NULL,                    0,   0,           0, 0,     0,    0,       0,    0,      0,   0,    NULL }
};
#define CONNECTBOX 1
#define NUMLCONNECT 3
#define LCONNECT1 2
#define RCONNECT1 LCONNECT1+NUMLCONNECT
#define NUMRCONNECT 15
#define SCALEBUTTON 21
#define SCALEFNBUTTON 22
#define CONNECTDRAWCHECK 25
#define DMULTSLIDER 26
#define DMULTTEXT 27
#define TRANSPOSESTACKCHECK 42
#define FACTORSTACKSCHECK 43
#define GOTOMAPBUTTON0 45
#define COPYMAPBUTTON0 56
#define CONNECTDONE 66
#define CONNECTCANCEL 67
#define CONNECTHELP 68

#define PSPREADSLIDER 31
#define PSPREADTEXT   32
#define DSPREADSLIDER 34
#define DSPREADTEXT   35
#define VSPREADSLIDER 37
#define VSPREADTEXT   38


#define PITCH    0
#define DURATION 1
#define VOLUME 2


void setconnectdialogto(int mnum);
void setmapfromdialog(int mnum);

int d_gotomapbutton_proc(int msg,DIALOG *d, int c){
       int ret=d_button_proc(msg, d, c);
       if(ret==D_CLOSE){
           setmapfromdialog(cureditmap);
           cureditmap=d->d1;
           setconnectdialogto(cureditmap);

           broadcast_dialog_message(MSG_DRAW,0);
           return D_O_K;
       }

       return ret;
}

char mapbuf[MAXMAPS][NUMLCONNECT][80];
int init_maps(){
   int i,j;
   strcpy(scalenamestring,scalenames[1]);
   strcpy(scalefnnamestring,scalefnnames[0]);
   pitchvariable=statevariablearray[X_VAR];
   durationvariable=statevariablearray[DRAWLENGTH_VAR];
   velocityvariable=statevariablearray[FX_VAR];
   for(i=0;i<MAXMAPS;i++){
        maps[i].pitch=&statevariablearray[X_VAR];
        maps[i].duration=&statevariablearray[DRAWLENGTH_VAR];
        maps[i].volume=&statevariablearray[FX_VAR];
        maps[i].pspread=pspread;
        maps[i].dspread=dspread;
        maps[i].vspread=vspread;
        maps[i].scale=(scales[1]);
        strcpy(maps[i].scalename,scalenames[1]);
        maps[i].scalefn=scalefunctions[0];
        maps[i].dmultiplier=dmultiplier;
        maps[i].tstack=transposestack_p;
        maps[i].fstacks=factstacks_p;
        maps[i].transpose=0;
        for(j=0;j<NUMLCONNECT;j++){
            *mapbuf[i][j]='\0';
        }
   }

   return 0;
}
int d_copymapbutton_proc(int msg,DIALOG *d, int c){
       int i;
       int ret=d_button_proc(msg, d, c);
       int copyfrom;
       if(ret==D_CLOSE){

        copyfrom=d->d1;
        maps[cureditmap].pitch=maps[copyfrom].pitch;
        maps[cureditmap].duration=maps[copyfrom].duration;
        maps[cureditmap].volume=maps[copyfrom].volume;
        maps[cureditmap].pspread=maps[copyfrom].pspread;
        maps[cureditmap].dspread=maps[copyfrom].dspread;
        maps[cureditmap].vspread=maps[copyfrom].vspread;
        maps[cureditmap].scale=maps[copyfrom].scale;
        strcpy(maps[cureditmap].scalename,maps[copyfrom].scalename);
        maps[cureditmap].scalefn=maps[copyfrom].scalefn;
        maps[cureditmap].dmultiplier=maps[copyfrom].dmultiplier;
        maps[cureditmap].transpose=maps[copyfrom].transpose;
        maps[cureditmap].tstack=maps[copyfrom].tstack;
        maps[cureditmap].fstacks=maps[copyfrom].fstacks;

        sprintf(transposestring,"%d",maps[cureditmap].transpose);

        scale2scalestring(&(maps[cureditmap].scale));
        strcpy(scalenamestring,maps[cureditmap].scalename);

        for (i=0;i<3;i++){
           if(maps[cureditmap].scalefn==scalefunctions[i])
               strcpy(scalefnnamestring,scalefnnames[i]);
        }
        for(i=0;i<NUMSTATEVARS;i++){
            if(maps[cureditmap].pitch->v==statevariablearray[i].v)
                       connect_dialog[LCONNECT1+PITCH].d1=i;
            if(maps[cureditmap].duration->v==statevariablearray[i].v)
                       connect_dialog[LCONNECT1+DURATION].d1=i;
            if(maps[cureditmap].volume->v==statevariablearray[i].v)
                       connect_dialog[LCONNECT1+VOLUME].d1=i;

        }
        connect_dialog[DMULTSLIDER].d2=(int)( (maps[cureditmap].dmultiplier)/4.0*100);
        sprintf(connect_dialog[DMULTTEXT].dp,"%1.3f",(maps[cureditmap].dmultiplier)/4.0);

        connect_dialog[PSPREADSLIDER].d2=(int)((maps[cureditmap].pspread+PSPREADMAX)/(2*PSPREADMAX)*70);
        sprintf(connect_dialog[PSPREADTEXT].dp,"%1.3f",maps[cureditmap].pspread);

        connect_dialog[DSPREADSLIDER].d2=(int)((maps[cureditmap].dspread+DSPREADMAX)/(2*DSPREADMAX)*70);
        sprintf(connect_dialog[DSPREADTEXT].dp,"%1.3f",maps[cureditmap].dspread);

        connect_dialog[VSPREADSLIDER].d2=(int)((maps[cureditmap].vspread+VSPREADMAX)/(2*VSPREADMAX)*70);
        sprintf(connect_dialog[VSPREADTEXT].dp,"%1.3f",maps[cureditmap].vspread);

        if(maps[cureditmap].tstack)
             connect_dialog[TRANSPOSESTACKCHECK].flags |= D_SELECTED;
        else connect_dialog[TRANSPOSESTACKCHECK].flags &= ~D_SELECTED;
        if(maps[cureditmap].fstacks)
             connect_dialog[FACTORSTACKSCHECK].flags |= D_SELECTED;
        else connect_dialog[FACTORSTACKSCHECK].flags &= ~D_SELECTED;

   
        broadcast_dialog_message(MSG_DRAW,0);
        return D_O_K;
       }
       return ret;
}

int connect_helpbutton_proc(int msg,DIALOG *d, int c){

        int ret=d_button_proc(msg, d, c);

        if(ret==D_CLOSE){
           ret=maphelp();

           return ret;
        }
        return(ret);
}

int d_connect_box_proc(int msg,DIALOG *d, int c){
    int ret;

    ret=d_box_proc(msg,d,c);
    if(msg==MSG_START){
         connect_bmp= create_bitmap(d->w,d->h);
         clear(connect_bmp);
    }
    else if(msg==MSG_END){
         destroy_bitmap(connect_bmp);
    }

    return ret;
}
int dumblit_proc(int msg,DIALOG *d,int c){
 int ret;
 if(msg==MSG_DRAW){
              blit(screen,connect_bmp,0,0,0,0,CONNECT_W,CONNECT_H);
 }
 ret=d_box_proc(msg,d,c);
 return(ret);
}

void circlelineproc(BITMAP * bmp,int x, int y,int c){
             circlefill(bmp,x,y,1,c);
}
int d_connect_l_proc(int msg,DIALOG *d, int c){
    int ret;
    int i;
    int mx=mouse_x,my=mouse_y;
    int oldmx=mx,oldmy=my;
    int tlx=connect_dialog[0].x;
    int tly=connect_dialog[0].y;
    DIALOG * rtendbut;

    if(msg==MSG_CLICK){
              unsavedmapchanges=1;
              broadcast_dialog_message(MSG_DRAW,0);
              show_mouse(NULL);
              blit(screen,connect_bmp,tlx,tly,0,0,CONNECT_W,CONNECT_H);
              show_mouse(screen);
              while(mouse_b&1){
                  mx=mouse_x;my=mouse_y;
                  if((oldmx!=mx || oldmy!=my) ){
                       show_mouse(NULL);
                       blit(connect_bmp,screen,0,0,tlx,tly,CONNECT_W,CONNECT_H);
                       if(mx<tlx+CONNECT_W-1 && my<tly+CONNECT_H-1 && mx>d->x+d->w && my>tly){

                          do_line(screen,d->x+d->w,d->y+1,mx,my+1,d->d2,circlelineproc);
                       }
                       show_mouse(screen);
                  }
                  oldmx=mx;oldmy=my;

              }

              for(i=0;i<NUMRCONNECT;i++){
                       rtendbut=&connect_dialog[RCONNECT1+i];
                       if(   mx>rtendbut->x && mx<rtendbut->x+rtendbut->w
                          && my>rtendbut->y && my<rtendbut->y+rtendbut->h)
                            break;
              }

              if(i<NUMRCONNECT){
                     d->d1=i;

              }
              else {
                 d->d1=-1;
              }
              d->flags &= ~D_SELECTED;
              broadcast_dialog_message(MSG_DRAW,0);
 
    }
    else if(msg==MSG_DRAW&& d->d1>=0){
          do_line(screen,d->x+d->w,d->y+1,connect_dialog[RCONNECT1+d->d1].x,connect_dialog[RCONNECT1+d->d1].y+1,d->d2,circlelineproc);
    }

    ret=d_button_proc(msg,d,c);
    return ret;
}

int d_connect_r_proc(int msg,DIALOG *d, int c){

    int ret;
    int i;
    int mx=mouse_x,my=mouse_y;
    int oldmx=mx,oldmy=my;
    int tlx=connect_dialog[0].x;
    int tly=connect_dialog[0].y;
    DIALOG * leftendbut;

    if(msg==MSG_CLICK){

              broadcast_dialog_message(MSG_DRAW,0);
              show_mouse(NULL);
              blit(screen,connect_bmp,tlx,tly,0,0,CONNECT_W,CONNECT_H);
              show_mouse(screen);
              while(mouse_b&1){
                  mx=mouse_x;my=mouse_y;
                  if((oldmx!=mx || oldmy!=my) ){
                       show_mouse(NULL);
                       blit(connect_bmp,screen,0,0,tlx,tly,CONNECT_W,CONNECT_H);
                       if(mx<tlx+CONNECT_W-1 && my<tly+CONNECT_H-1 && mx<d->x && my>tly){

                          do_line(screen,d->x,d->y+1,mx,my+1,5,circlelineproc);
                       }
                       show_mouse(screen);
                  }
                  oldmx=mx;oldmy=my;

              }

              for(i=0;i<NUMLCONNECT;i++){
                       leftendbut=&connect_dialog[LCONNECT1+i];
                       if(   mx>leftendbut->x && mx<leftendbut->x+leftendbut->w
                          && my>leftendbut->y && my<leftendbut->y+leftendbut->h)
                            break;
              }

              if(i<NUMLCONNECT){
                     leftendbut->d1=d->d1;
                     unsavedmapchanges=1;
              }
              broadcast_dialog_message(MSG_DRAW,0);
 
    }
    d->flags&=~D_SELECTED;
    ret=d_button_proc(msg,d,c);

    return ret;
}


void setconnectdialogto(int mnum){
   int i;
   MAP * m=&(maps[mnum]);

   sprintf(mapnumberstring,"Map #%d",mnum);
   scale2scalestring(&(m->scale));
   strcpy(scalenamestring,m->scalename);
   sprintf(transposestring,"%d",m->transpose);
   for(i=0;i<MAXMAPS;i++){
          connect_dialog[GOTOMAPBUTTON0+i].flags &= ~D_DISABLED;
          connect_dialog[COPYMAPBUTTON0+i].flags &= ~D_DISABLED;
   }
   connect_dialog[GOTOMAPBUTTON0+mnum].flags |= D_DISABLED;
   connect_dialog[COPYMAPBUTTON0+mnum].flags |= D_DISABLED;
   for (i=0;i<3;i++){
      if(m->scalefn==scalefunctions[i])
          strcpy(scalefnnamestring,scalefnnames[i]);
   }
   for(i=0;i<NUMSTATEVARS;i++){
            if(m->pitch->v==statevariablearray[i].v)
                       connect_dialog[LCONNECT1+PITCH].d1=i;
            if(m->duration->v==statevariablearray[i].v)
                       connect_dialog[LCONNECT1+DURATION].d1=i;
            if(m->volume->v==statevariablearray[i].v)
                       connect_dialog[LCONNECT1+VOLUME].d1=i;

   }

   if(m->dmultiplier>4.0*DMULTMAX) m->dmultiplier=4.0*DMULTMAX;
   if(m->dmultiplier<0) m->dmultiplier=0;
   connect_dialog[DMULTSLIDER].d2=(int)( (m->dmultiplier)/4.0*100);
   sprintf(connect_dialog[DMULTTEXT].dp,"%1.3f",(m->dmultiplier)/4.0);

   if(m->pspread>PSPREADMAX) m->pspread=PSPREADMAX;
   if(m->pspread<-PSPREADMAX) m->pspread=-PSPREADMAX;
   connect_dialog[PSPREADSLIDER].d2=(int)((m->pspread+PSPREADMAX)/(2*PSPREADMAX)*70);
   sprintf(connect_dialog[PSPREADTEXT].dp,"%1.3f",m->pspread);

   if(m->dspread >  DSPREADMAX) m->dspread =  DSPREADMAX;
   if(m->dspread < -DSPREADMAX) m->dspread = -DSPREADMAX;
   connect_dialog[DSPREADSLIDER].d2=(int)((m->dspread+DSPREADMAX)/(2*DSPREADMAX)*70);
   sprintf(connect_dialog[DSPREADTEXT].dp,"%1.3f",m->dspread);

   if(m->vspread>VSPREADMAX) m->vspread=VSPREADMAX;
   if(m->vspread<-VSPREADMAX) m->vspread=-VSPREADMAX;
   connect_dialog[VSPREADSLIDER].d2=(int)((m->vspread+VSPREADMAX)/(2*VSPREADMAX)*70);
   sprintf(connect_dialog[VSPREADTEXT].dp,"%1.3f",m->vspread);

   if(m->tstack)
      connect_dialog[TRANSPOSESTACKCHECK].flags |= D_SELECTED;

   else connect_dialog[TRANSPOSESTACKCHECK].flags &= ~D_SELECTED;
   if(m->fstacks)
      connect_dialog[FACTORSTACKSCHECK].flags |= D_SELECTED;

   else connect_dialog[FACTORSTACKSCHECK].flags &= ~D_SELECTED;

   sprintf(deltaanglestring,"%3.2f",deltaangledeg);
}
void setmapfromdialog(int mnum){
   int i;
   DIALOG *d;
   MAP * m=&(maps[mnum]);
   if(connect_dialog[TRANSPOSESTACKCHECK].flags&D_SELECTED)
         m->tstack=1;
   else m->tstack=0;


   if(connect_dialog[FACTORSTACKSCHECK].flags&D_SELECTED)
         m->fstacks=1;
   else m->fstacks=0;

   deltaangledeg=atof(deltaanglestring);

   m->dmultiplier=4.0*atof(dmultbuf);
   if(m->dmultiplier>4.0*DMULTMAX) m->dmultiplier=4.0*DMULTMAX;
   if(m->dmultiplier<0) m->dmultiplier=0;
   m->pspread=atof(pspreadbuf);
   if(m->pspread>PSPREADMAX) m->pspread=PSPREADMAX;
   if(m->pspread<-PSPREADMAX) m->pspread=-PSPREADMAX;

   m->dspread=atof(dspreadbuf);
   if(m->dspread>DSPREADMAX) m->dspread=DSPREADMAX;
   if(m->dspread<-DSPREADMAX) m->dspread=-DSPREADMAX;

   m->vspread=atof(vspreadbuf);
   if(m->vspread>VSPREADMAX) m->vspread=VSPREADMAX;
   if(m->vspread<-VSPREADMAX) m->vspread=-VSPREADMAX;

   m->transpose=atoi(transposestring);

   for (i=0;i<NUMLCONNECT;i++){
            d=&connect_dialog[LCONNECT1+i];
            if (d->d1 >=0){
               switch(i){
                    case PITCH:
                         m->pitch=&statevariablearray[d->d1];
                         break;
                    case DURATION:
                         m->duration=&statevariablearray[d->d1];
                         break;
                    case VOLUME:
                         m->volume=&statevariablearray[d->d1];
                         break;

               }

               sprintf(mapbuf[mnum][i],"%s=%s",(char *)d->dp,(char *)connect_dialog[RCONNECT1+d->d1].dp);

            }
            else{
               sprintf(mapbuf[mnum][i],"%s=nothing",(char *)d->dp);
               switch(i){
                    case PITCH:
                         m->pitch=&constantvar;
                         break;
                    case DURATION:
                         m->duration=&constantvar;
                         break;
                    case VOLUME:
                         m->volume=&constantvar;
                         break;

               }
            }
   }

}


int  do_mconnect_dialog(int mnum){

   int ret=0;

   cureditmap=mnum;
   setconnectdialogto(mnum);

   centre_dialog(connect_dialog);
   ret=popup_dialog(connect_dialog,0);

   if(ret==CONNECTCANCEL||ret==-1){

           return -1;
   }
   setmapfromdialog(cureditmap);
   return ret;
}

#define LBG 8
char limitstring[NUMSTATEVARS+1][120];
DIALOG seelimits_dialog[]={

   {d_box_proc,      0,   0,    260,  310,   255,  LBG,       0,   0,      0,   0,   NULL},

   {d_text_proc,     10,  30,    0,    0,    255,  3,       0,   0,      0,   0,   limitstring[0]},
   {d_text_proc,     10,  46,    0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[1]},
   {d_text_proc,     10,  62,    0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[2]},
   {d_text_proc,     10,  78,    0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[3]},
   {d_text_proc,     10,  94,    0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[4]},
   {d_text_proc,     10,  110,   0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[5]},
   {d_text_proc,     10,  126,   0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[6]},
   {d_text_proc,     10,  142,   0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[7]},
   {d_text_proc,     10,  158,   0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[8]},
   {d_text_proc,     10,  174,   0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[9]},
   {d_text_proc,     10,  190,   0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[10]},
   {d_text_proc,     10,  206,   0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[11]},
   {d_text_proc,     10,  222,   0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[12]},
   {d_text_proc,     10,  238,   0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[13]},
   {d_text_proc,     10,  254,   0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[14]},
   {d_text_proc,     10,  270,   0,    0,    255,  LBG,       0,   0,      0,   0,   limitstring[15]},

   { d_button_proc,  5,   5,    16,   16,    255,  0,         13,  D_EXIT, 0,   0,    "X" },
   { d_button_proc,  114, 290,  32,   16,    255,  0,         13,  D_EXIT, 0,   0,    "OK" },
   { NULL,           0,   0,    0,    0,    0,    0,       0,   0,      0,   0,    NULL }
};

int seelimits_proc(int msg, DIALOG *d, int c){
    int ret=d_button_proc(msg,d,c);
    if(ret==D_CLOSE){
          sprintf(limitstring[0], "variable        min      max ");
          sprintf(limitstring[1], "x            %7.2f  %7.2f",minx,maxx);
          sprintf(limitstring[2], "y            %7.2f  %7.2f",miny,maxy);
          sprintf(limitstring[3], "z            %7.2f  %7.2f",minz,maxz);
          sprintf(limitstring[4], "forward x    %7.2f  %7.2f",fminx,fmaxx);
          sprintf(limitstring[5], "forward y    %7.2f  %7.2f",fminy,fmaxy);
          sprintf(limitstring[6], "forward z    %7.2f  %7.2f",fminz,fmaxz);
          sprintf(limitstring[7], "up x         %7.2f  %7.2f",uminx,umaxx);
          sprintf(limitstring[8], "up y         %7.2f  %7.2f",uminy,umaxy);
          sprintf(limitstring[9], "up z         %7.2f  %7.2f",uminz,umaxz);
          sprintf(limitstring[10],"left x       %7.2f  %7.2f",lminx,lmaxx);
          sprintf(limitstring[11],"left y       %7.2f  %7.2f",lminy,lmaxy);
          sprintf(limitstring[12],"left z       %7.2f  %7.2f",lminz,lmaxz);
          sprintf(limitstring[13],"state length %7.2f  %7.2f",minlength,maxlength);
          sprintf(limitstring[14],"draw length  %7.2f  %7.2f",mindrawlength,maxdrawlength);
          sprintf(limitstring[15],"thickness    %7.2f  %7.2f",minthickness,maxthickness);
          centre_dialog(seelimits_dialog);
          popup_dialog(seelimits_dialog,-1);
          return D_O_K;
    }
    return ret;
}

float holddmultiplier;
int setdmult(void *dp3 __attribute__ ((unused)), int d2)
{
        DIALOG *dtext=&connect_dialog[DMULTTEXT];
        holddmultiplier=4.0*(float)(d2)/100;

        sprintf(connect_dialog[DMULTTEXT].dp,"%1.3f",holddmultiplier/4.0);
        rectfill(screen,dtext->x,dtext->y, dtext->x + dtext->w,dtext->y + dtext->h,dtext->bg);
        show_mouse(NULL);
        d_edit_proc(MSG_DRAW,dtext,0);
        show_mouse(screen);
        unsavedmapchanges=1;
        return(0);
}
float holdpspread;
int setpspread(void *dp3 __attribute__ ((unused)), int d2)
{
        DIALOG *dtext=&connect_dialog[PSPREADTEXT];

        holdpspread=-PSPREADMAX+2*PSPREADMAX*(float)(d2)/70;
        sprintf(connect_dialog[PSPREADTEXT].dp,"%1.3f",holdpspread);
        rectfill(screen,dtext->x,dtext->y, dtext->x + dtext->w,dtext->y + dtext->h,dtext->bg);
        show_mouse(NULL);
        d_edit_proc(MSG_DRAW,dtext,0);
        show_mouse(screen);
        unsavedmapchanges=1;
        return(0);
}
float holddspread;
int setdspread(void *dp3 __attribute__ ((unused)), int d2)
{
        DIALOG *dtext=&connect_dialog[DSPREADTEXT];

        holddspread=-DSPREADMAX+2*DSPREADMAX*(float)(d2)/70;

        sprintf(connect_dialog[DSPREADTEXT].dp,"%1.3f",holddspread);
        rectfill(screen,dtext->x,dtext->y, dtext->x + dtext->w,dtext->y + dtext->h,dtext->bg);
        show_mouse(NULL);
        d_edit_proc(MSG_DRAW,dtext,0);
        show_mouse(screen);
        unsavedmapchanges=1;
        return(0);
}

float holdvspread;
int setvspread(void *dp3 __attribute__ ((unused)), int d2)
{
        DIALOG *dtext=&connect_dialog[VSPREADTEXT];

        holdvspread=-VSPREADMAX+2*VSPREADMAX*(float)(d2)/70;

        sprintf(connect_dialog[VSPREADTEXT].dp,"%1.3f",holdvspread);
        rectfill(screen,dtext->x,dtext->y, dtext->x + dtext->w,dtext->y + dtext->h,dtext->bg);
        show_mouse(NULL);
        d_edit_proc(MSG_DRAW,dtext,0);
        show_mouse(screen);
        unsavedmapchanges=1;
        return(0);
}

#define MAXINILINE 255
int readinifile(){
    FILE *fp;
    MAP * m=&maps[cureditmap];

    int mnum;
    char *bptr,*rptr,*eqptr,*lptr;
    char buffer[MAXINILINE+1];
    SCALE * udefed_scale;

    fp=fopen(inifile,"rt");
    if(fp==NULL) return -1;

    while(fgets(buffer,MAXINILINE,fp)){

        bptr=buffer;
        while(isspace(*bptr)) bptr++;
        lptr=bptr;
        while(*lptr!='\0'){
           if(*lptr==commentchar||*lptr=='\n'){
              *lptr='\0';
              break;
           }
           lptr++;

        }
        if(*bptr== '@') break;/* "@" is lparser end mark*/
        if(*bptr!='\0'){
                        eqptr=strchr(bptr,'=');
                        if(eqptr!=NULL){
                             lptr=bptr;rptr=eqptr+1;
                             *eqptr='\0';
                             formatline(lptr);
                             while(isspace(*rptr)) rptr++;
                             if(!stricmp(lptr,"mapnumber")){
                                    mnum=atoi(rptr);
                                    if(mnum>=0&&mnum<MAXMAPS)
                                        m=&maps[mnum];
                                    else
                                        m=&maps[0];
                             }
                             if(!stricmp(lptr,"tempo")){
                                    tempo=atol(rptr);
                             }
                             else if(!stricmp(lptr,"transpose")){
                                    m->transpose=atoi(rptr);
                             }
                             else if(!stricmp(lptr,"pspread")){
                                    m->pspread=atof(rptr);
                                    if(m->pspread>PSPREADMAX) m->pspread=PSPREADMAX;
                                    if(m->pspread<-PSPREADMAX) m->pspread=-PSPREADMAX;

                             }
                             else if(!stricmp(lptr,"dspread")){
                                    m->dspread=atof(rptr);
                                    if(m->dspread>DSPREADMAX) m->dspread=DSPREADMAX;
                                    if(m->dspread<-DSPREADMAX) m->dspread=-DSPREADMAX;
                             }
                             else if(!stricmp(lptr,"vspread")){
                                    m->vspread=atof(rptr);
                                    if(m->vspread>VSPREADMAX) m->vspread=VSPREADMAX;
                                    if(m->vspread<-VSPREADMAX) m->vspread=-VSPREADMAX;

                             }
                             else if(!stricmp(lptr,"pitch")){
                                  formatline(rptr);
                                  if(!stricmp(rptr,"x"))
                                       m->pitch=&statevariablearray[X_VAR];
                                  else if(!stricmp(rptr,"y"))
                                       m->pitch=&statevariablearray[Y_VAR];
                                  else if(!stricmp(rptr,"z"))
                                       m->pitch=&statevariablearray[Z_VAR];

                                  else if(!stricmp(rptr,"forwardx")||!stricmp(rptr,"fx"))
                                       m->pitch=&statevariablearray[FX_VAR];
                                  else if(!stricmp(rptr,"forwardy")||!stricmp(rptr,"fy"))
                                       m->pitch=&statevariablearray[FY_VAR];
                                  else if(!stricmp(rptr,"forwardz")||!stricmp(rptr,"fz"))
                                       m->pitch=&statevariablearray[FZ_VAR];

                                  else if(!stricmp(rptr,"upx")||!stricmp(rptr,"ux"))
                                       m->pitch=&statevariablearray[UX_VAR];
                                  else if(!stricmp(rptr,"upy")||!stricmp(rptr,"uy"))
                                       m->pitch=&statevariablearray[UY_VAR];
                                  else if(!stricmp(rptr,"upz")||!stricmp(rptr,"uz"))
                                       m->pitch=&statevariablearray[UZ_VAR];
                                  else if(!stricmp(rptr,"leftx")||!stricmp(rptr,"lx"))
                                       m->pitch=&statevariablearray[LX_VAR];
                                  else if(!stricmp(rptr,"lefty")||!stricmp(rptr,"ly"))
                                       m->pitch=&statevariablearray[LY_VAR];
                                  else if(!stricmp(rptr,"leftz")||!stricmp(rptr,"lz"))
                                       m->pitch=&statevariablearray[LZ_VAR];

                                  else if(!stricmp(rptr,"length")||!stricmp(rptr,"statelength"))
                                       m->pitch=&statevariablearray[LENGTH_VAR];
                                  else if(!stricmp(rptr,"drawlength")||!stricmp(rptr,"dlength"))
                                       m->pitch=&statevariablearray[DRAWLENGTH_VAR];
                                  else if(!stricmp(rptr,"thickness")||!stricmp(rptr,"thick"))
                                       m->pitch=&statevariablearray[THICKNESS_VAR];
                             }
                             else if(!stricmp(lptr,"duration")){
                                  formatline(rptr);
                                  if(!stricmp(rptr,"x"))
                                       m->duration=&statevariablearray[X_VAR];
                                  else if(!stricmp(rptr,"y"))
                                       m->duration=&statevariablearray[Y_VAR];
                                  else if(!stricmp(rptr,"z"))
                                       m->duration=&statevariablearray[Z_VAR];

                                  else if(!stricmp(rptr,"forwardx")||!stricmp(rptr,"fx"))
                                       m->duration=&statevariablearray[FX_VAR];
                                  else if(!stricmp(rptr,"forwardy")||!stricmp(rptr,"fy"))
                                       m->duration=&statevariablearray[FY_VAR];
                                  else if(!stricmp(rptr,"forwardz")||!stricmp(rptr,"fz"))
                                       m->duration=&statevariablearray[FZ_VAR];

                                  else if(!stricmp(rptr,"upx")||!stricmp(rptr,"ux"))
                                       m->duration=&statevariablearray[UX_VAR];
                                  else if(!stricmp(rptr,"upy")||!stricmp(rptr,"uy"))
                                       m->duration=&statevariablearray[UY_VAR];
                                  else if(!stricmp(rptr,"upz")||!stricmp(rptr,"uz"))
                                       m->duration=&statevariablearray[UZ_VAR];
                                  else if(!stricmp(rptr,"leftx")||!stricmp(rptr,"lx"))
                                       m->duration=&statevariablearray[LX_VAR];
                                  else if(!stricmp(rptr,"lefty")||!stricmp(rptr,"ly"))
                                       m->duration=&statevariablearray[LY_VAR];
                                  else if(!stricmp(rptr,"leftz")||!stricmp(rptr,"lz"))
                                       m->duration=&statevariablearray[LZ_VAR];

                                  else if(!stricmp(rptr,"length"))
                                       m->duration=&statevariablearray[LENGTH_VAR];
                                  else if(!stricmp(rptr,"drawlength")||!stricmp(rptr,"dlength"))
                                       m->duration=&statevariablearray[DRAWLENGTH_VAR];
                                  else if(!stricmp(rptr,"thickness")||!stricmp(rptr,"thick"))
                                       m->duration=&statevariablearray[THICKNESS_VAR];
                             }
                             else if( !stricmp(lptr,"velocity") || !stricmp(lptr,"volume")){
                                  formatline(rptr);
                                  if(!stricmp(rptr,"x"))
                                       m->volume=&statevariablearray[X_VAR];
                                  else if(!stricmp(rptr,"y"))
                                       m->volume=&statevariablearray[Y_VAR];
                                  else if(!stricmp(rptr,"z"))
                                       m->volume=&statevariablearray[Z_VAR];

                                  else if(!stricmp(rptr,"forwardx")||!stricmp(rptr,"fx"))
                                       m->volume=&statevariablearray[FX_VAR];
                                  else if(!stricmp(rptr,"forwardy")||!stricmp(rptr,"fy"))
                                       m->volume=&statevariablearray[FY_VAR];
                                  else if(!stricmp(rptr,"forwardz")||!stricmp(rptr,"fz"))
                                       m->volume=&statevariablearray[FZ_VAR];

                                  else if(!stricmp(rptr,"upx")||!stricmp(rptr,"ux"))
                                       m->volume=&statevariablearray[UX_VAR];
                                  else if(!stricmp(rptr,"upy")||!stricmp(rptr,"uy"))
                                       m->volume=&statevariablearray[UY_VAR];
                                  else if(!stricmp(rptr,"upz")||!stricmp(rptr,"uz"))
                                       m->volume=&statevariablearray[UZ_VAR];
                                  else if(!stricmp(rptr,"leftx")||!stricmp(rptr,"lx"))
                                       m->volume=&statevariablearray[LX_VAR];
                                  else if(!stricmp(rptr,"lefty")||!stricmp(rptr,"ly"))
                                       m->volume=&statevariablearray[LY_VAR];
                                  else if(!stricmp(rptr,"leftz")||!stricmp(rptr,"lz"))
                                       m->volume=&statevariablearray[LZ_VAR];

                                  else if(!stricmp(rptr,"length"))
                                       m->volume=&statevariablearray[LENGTH_VAR];
                                  else if(!stricmp(rptr,"drawlength")||!stricmp(rptr,"dlength"))
                                       m->volume=&statevariablearray[DRAWLENGTH_VAR];
                                  else if(!stricmp(rptr,"thickness")||!stricmp(rptr,"thick"))
                                       m->volume=&statevariablearray[THICKNESS_VAR];

                             }
                             else if( !stricmp(lptr,"scale") ){
                                  if(isdigit(*rptr)){
                                       udefed_scale=string2scale(rptr);
                                       if(udefed_scale!=NULL){
                                          scale2scalestring(udefed_scale);
                                          m->scale=*udefed_scale;
                                          strcpy(m->scalename,scalenames[7]);
                                          strcpy(scalenamestring,scalenames[7]);

                                       }
                                  }
                                  else{
                                       formatline(rptr);
                                       if(!stricmp(rptr,"twelvetone")){
                                          m->scale=scales[0];
                                          strcpy(m->scalename,scalenames[0]);
                                          strcpy(scalenamestring,scalenames[0]);
                                       }
                                       else if(!stricmp(rptr,"major")){
                                          m->scale=scales[1];
                                          strcpy(m->scalename,scalenames[1]);
                                          strcpy(scalenamestring,scalenames[1]);
                                       }
                                       else if(!stricmp(rptr,"penta1")){
                                          m->scale=scales[2];
                                          strcpy(m->scalename,scalenames[2]);
                                          strcpy(scalenamestring,scalenames[2]);
                                       }
                                       else if(!stricmp(rptr,"minor")){
                                          m->scale=scales[3];
                                          strcpy(m->scalename,scalenames[3]);                                          
                                          strcpy(scalenamestring,scalenames[3]);
                                       }
                                       else if(!stricmp(rptr,"blue1")){
                                          m->scale=scales[4];
                                          strcpy(m->scalename,scalenames[4]);
                                          strcpy(scalenamestring,scalenames[4]);
                                       }
                                       else if(!stricmp(rptr,"whole")){
                                          m->scale=scales[5];
                                          strcpy(m->scalename,scalenames[5]);
                                          strcpy(scalenamestring,scalenames[5]);
                                       }
                                       else if(!stricmp(rptr,"diminished")){
                                          m->scale=scales[6];
                                          strcpy(m->scalename,scalenames[6]);                                          
                                          strcpy(scalenamestring,scalenames[6]);
                                       }

                                  }
                             }
                             else if(!stricmp(lptr,"scalefn")){
                                       formatline(rptr);
                                       if(!stricmp(rptr,"constant")){
                                          m->scalefn=scalefunctions[CONSTANTSCALE];
                                          strcpy(scalefnnamestring,scalefnnames[CONSTANTSCALE]);
                                       }
                                       else if(!stricmp(rptr,"slideto")){
                                          m->scalefn=scalefunctions[SLIDETOSCALE];
                                          strcpy(scalefnnamestring,scalefnnames[SLIDETOSCALE]);

                                       }
                                       else if(!stricmp(rptr,"steps")){
                                          m->scalefn=scalefunctions[SCALESTEPS];
                                          strcpy(scalefnnamestring,scalefnnames[SCALESTEPS]);

                                       }
                                       else if(!stricmp(rptr,"ignore")){
                                          m->scalefn=scalefunctions[IGNORESCALE];
                                          strcpy(scalefnnamestring,scalefnnames[IGNORESCALE]);

                                       }

                             }
                             else if(!stricmp(lptr,"dmultiplier")){
                                  m->dmultiplier=4.0*fabs(atof(rptr));
                                  if(m->dmultiplier>4.0*DMULTMAX) m->dmultiplier=4.0*DMULTMAX;
                                  if(m->dmultiplier<0) m->dmultiplier=0;

                             }
                             else if(!stricmp(lptr,"tstack") ||!stricmp(lptr,"transposestack")){
                                       formatline(rptr);
                                       if(!stricmp(rptr,"1")||!stricmp(rptr,"yes")||!stricmp(rptr,"y")||!stricmp(rptr,"on")){
                                          transposestack_p=1;
                                          m->tstack=1;
                                       }
                                       else {
                                          transposestack_p=0;
                                          m->tstack=0;
                                       }
                             }
                             else if(!stricmp(lptr,"fstacks") ||!stricmp(lptr,"factorstacks")){
                                       formatline(rptr);
                                       if(!stricmp(rptr,"1")||!stricmp(rptr,"yes")||!stricmp(rptr,"y")||!stricmp(rptr,"on")){
                                          factstacks_p=1;
                                          m->fstacks=1;
                                       }
                                       else{
                                          factstacks_p=0;
                                          m->fstacks=0;
                                       }
                             }
                             else if(!stricmp(lptr,"seed") ||!stricmp(lptr,"randomseed")){
                                       rstart=(unsigned)atoi(rptr);
                                       lastseed=rstart;
                             }
                        }/*if anything after '='*/
        }/*if this is a noncomment line*/

    }
    useinifile=1;
    fclose(fp);
    return 0;
}

int getinibutton_proc(int msg,DIALOG *d, int c){
        int obj;
        int i;
        MAP *m=&maps[cureditmap];
        DIALOG *cd=connect_dialog;
        int ret=d_button_proc(msg, d, c);

        if(ret==D_CLOSE){
           if(c!=255){
               connect_dialog[CONNECTDONE].flags|=D_DISABLED;
               connect_dialog[CONNECTCANCEL].flags|=D_DISABLED;
               connect_dialog[CONNECTHELP].flags|=D_DISABLED;
               dialog_message(&(connect_dialog[CONNECTDONE]), MSG_DRAW, 0, &obj);
               dialog_message(&(connect_dialog[CONNECTCANCEL]), MSG_DRAW, 0, &obj);
               dialog_message(&(connect_dialog[CONNECTHELP]), MSG_DRAW, 0, &obj);
           }
           ret=getinifile();

           for(i=0;i<NUMSTATEVARS;i++){
               if(m->pitch->v==statevariablearray[i].v)
                          connect_dialog[LCONNECT1+PITCH].d1=i;
               if(m->duration->v==statevariablearray[i].v)
                          connect_dialog[LCONNECT1+DURATION].d1=i;
               if(m->volume->v==statevariablearray[i].v)
                          connect_dialog[LCONNECT1+VOLUME].d1=i;

           }
           connect_dialog[DMULTSLIDER].d2=(int)(m->dmultiplier/4.0*100);
           sprintf(connect_dialog[DMULTTEXT].dp,"%1.2f",m->dmultiplier/4.0);

           connect_dialog[PSPREADSLIDER].d2=(int)((m->pspread+PSPREADMAX)/(2*PSPREADMAX)*70);
           sprintf(connect_dialog[PSPREADTEXT].dp,"%1.2f",m->pspread);

           connect_dialog[DSPREADSLIDER].d2=(int)((m->dspread+DSPREADMAX)/(2*DSPREADMAX)*70);
           sprintf(connect_dialog[DSPREADTEXT].dp,"%1.2f",m->dspread);

           connect_dialog[VSPREADSLIDER].d2=(int)((m->vspread+VSPREADMAX)/(2*VSPREADMAX)*70);
           sprintf(connect_dialog[VSPREADTEXT].dp,"%1.2f",m->vspread);
           sprintf(deltaanglestring,"%3.2f",deltaangledeg);
           strcpy(scalenamestring,m->scalename);
           for (i=0;i<3;i++){
             if(m->scalefn==scalefunctions[i])
               strcpy(scalefnnamestring,scalefnnames[i]);
           }

           if(c!=255){
               connect_dialog[CONNECTDONE].flags&=~D_DISABLED;
               connect_dialog[CONNECTCANCEL].flags&=~D_DISABLED;
               connect_dialog[CONNECTHELP].flags&=~D_DISABLED;
               dialog_message(cd, MSG_DRAW, 0, &obj);

           }
           return ret;
        }
        return(ret);
}

int getinifile(){
     int fsret=1,alertret;
     char ininamebuf[256];
     char buf[100];
     strcpy(ininamebuf,inifile);
     while (fsret){
          fsret=popup_file_select("Load INI/MAP File:", ininamebuf, "ini;map");
          if(fsret==0) return D_O_K;
          if(!exists(ininamebuf)){
               sprintf(buf, "Can't find %s", ininamebuf);
               alertret=alert3(buf, NULL, NULL, "OK", "Try again","Cancel", 13,'t', 27) ;
               if(alertret==1) return D_O_K;
               else if (alertret == 3)
                  return 0;
               else if(alertret==2){
                  fsret=1;
               }
          }
          else {
             fsret=0;
             strcpy(inifile,ininamebuf);
          }
     }

     readinifile();

     return D_O_K;


}

int writeinifile(int mapnumber){
        FILE *fp;
        time_t now;
        int i;
        int writeall=0;
        MAP *m;
        char buf[120];
        if(mapnumber<0){
            mapnumber=0;
            writeall=1;
        }

        m=&maps[mapnumber];
        fp=fopen(inifile,"wt");
        if(fp==NULL) return -1;


        time(&now);
        fprintf(fp,"# LMUSe v%s map file %s\n# %s", PROGRAMVERSION,get_filename(inifile),asctime(localtime(&now)));
        fprintf(fp,"# Current rulefile: %s %s\n",*rulefile?get_filename(rulefile):"(none)", originalmutated?": (mutated)":"");

        fprintf(fp,"# Everything to the right of '#' on a line is ignored.\n");
        fprintf(fp,"# Each map line is of the form 'parameter=value'.\n");
        fprintf(fp,"# Including any of these parameter fields is optional.\n");
        fprintf(fp,"# Letter cases in map files are ignored.\n");


        fprintf(fp,"\n# tempo in beats per minute\n");
        fprintf(fp,"tempo=%ld\n",tempo);

        fprintf(fp,"\n# transposestack is a special stack for transposing the generated\n");
        fprintf(fp,"# pitches. (L-system symbols T(x) ... T ).\n");
        fprintf(fp,"# transposestack=1 enables this stack.\n");
        fprintf(fp, "transposestack=%d\n",m->tstack?1:0);

        fprintf(fp,"\n# factorstacks are special stacks for holding duration and volume\n");
        fprintf(fp,"# multipliers. (L-system symbols D(x) ... D , and V(x) ... V ).\n");
        fprintf(fp,"# factorstacks=1 enables these stacks.\n");
        fprintf(fp, "factorstacks=%d\n",m->fstacks?1:0);

        fprintf(fp, "\n# randomseed is an (unsigned) integer\n");
        fprintf(fp, "# To actually use this seed you need to\n");
        fprintf(fp, "# uncheck 'Random Seed' in the dialog presented\n");
        fprintf(fp, "# when doing a 'Make' or 'Remake'\n");
        fprintf(fp, "randomseed=%u\n",rstart);
        if(writeall){

           fprintf(fp, "\n# mapnumber tells which map (0 thru 9) the following\n");
           fprintf(fp, "# (up to the next mapnumber statement) are supposed to go\n");
           fprintf(fp, "# into when the file is loaded. mapnumber statements are\n");
           fprintf(fp, "# necessary to include several maps in a single map file\n");
           fprintf(fp, "mapnumber=%d\n",mapnumber);

        }

        fprintf(fp,"\n# pitch, duration, and volume of notes are each determined by\n");
        fprintf(fp,"# any one of the following L-system variables:\n");
        fprintf(fp,"# x          - the x coordinate of the turtle's position\n");
        fprintf(fp,"# y          - the y coordinate of the turtle's position\n");
        fprintf(fp,"# z          - the z coordinate of the turtle's position\n");
        fprintf(fp,"# forwardx   - (or 'fx') the x component of the turtle's forward direction\n");
        fprintf(fp,"# forwardy   - (or 'fy') the y component of the turtle's forward direction\n");
        fprintf(fp,"# forwardz   - (or 'fz') the z component of the turtle's forward direction\n");
        fprintf(fp,"# leftx      - (or 'lx') the x component of the turtle's 'left' orientation\n");
        fprintf(fp,"# lefty      - (or 'ly') the y component of the turtle's 'left' orientation\n");
        fprintf(fp,"# leftz      - (or 'lz') the z component of the turtle's 'left' orientation\n");
        fprintf(fp,"# upx        - the x component of the turtle's 'up' orientation\n");
        fprintf(fp,"# upy        - the y component of the turtle's 'up' orientation\n");
        fprintf(fp,"# upz        - the z component of the turtle's 'up' orientation\n");
        fprintf(fp,"# length     - (or 'statelength') the state length of the L-system\n");
        fprintf(fp,"# drawlength - the 'draw length' (affected by temporary length modifiers)\n");
        fprintf(fp,"# thickness  - the Lparser line thickness\n");


        for(i=0;i<3;i++){
           strcpy(buf,mapbuf[mapnumber][i]);
           formatline(buf);

           fprintf(fp,"%s\n",buf);
        }
        fprintf(fp,"\n# pspread, dspread, and vspread are magnifiers for the influence\n");
        fprintf(fp,"# of the pitch, duration and volume parameters on the notes generated.\n");
        fprintf(fp,"# Recommended to stay in interval -4.0 to 4.0\n");
        fprintf(fp,"pspread=%f\ndspread=%f\nvspread=%f\n",m->pspread,m->dspread,m->vspread);

        fprintf(fp,"\n# 'scale=scalename' tells LMUSe what scale to use.\n");
        fprintf(fp,"# The predefined scale choices are 'Major', 'minor', 'Blue1', 'Penta1',\n");
        fprintf(fp,"# 'diminished', 'Twelvetone', or 'whole'.\n");
        fprintf(fp,"# Alternatively, you can give a list of number halfsteps from\n");
        fprintf(fp,"# starting with the number '1'. For example, a major scale\n");
        fprintf(fp,"# could be given by: scale=1,3,5,6,8,10,12\n");

        if(!(stricmp(m->scalename,scalenames[numpredefinedscales]))){
             scale2scalestring( &(m->scale));
             sprintf(buf,"scale=%s",scalestring);
        }
        else{
             sprintf(buf,"scale=%s",m->scalename);
             formatline(buf);
        }
        fprintf(fp,"%s\n",buf);

        fprintf(fp,"\n# scalefn is the algorithm used to get the pitches to conform to the\n");
        fprintf(fp,"# desired musical scale. (see LMUSe.txt)\n");
        fprintf(fp,"# Choices are: slideto, steps, constant, ignore\n");
        for (i=0;i<3;i++){
           if(m->scalefn==scalefunctions[i])
               strcpy(scalefnnamestring,scalefnnames[i]);
        }
        sprintf(buf,"scalefn=%s",scalefnnamestring);
        formatline(buf);
        fprintf(fp,"%s\n",buf);

        fprintf(fp,"\n# transpose amount\n");
        fprintf(fp,"transpose=%d\n",m->transpose);

        fprintf(fp,"\n# duration multiplier\n");
        fprintf(fp,"dmultiplier=%f\n",m->dmultiplier/4.0);


        if(writeall){
          for(mapnumber=1;mapnumber<MAXMAPS;mapnumber++){
             m=&maps[mapnumber];
          
             fprintf(fp, "\nmapnumber=%d\n",mapnumber);


             for(i=0;i<3;i++){
                strcpy(buf,mapbuf[mapnumber][i]);
                formatline(buf);
                if(*buf)
                    fprintf(fp,"%s\n",buf);
             }
             fprintf(fp,"pspread=%f\ndspread=%f\nvspread=%f\n",m->pspread,m->dspread,m->vspread);
             if(!(stricmp(m->scalename,scalenames[numpredefinedscales]))){

                  scale2scalestring( &(m->scale));
                  sprintf(buf,"scale=%s",scalestring);
             }
             else{
                  sprintf(buf,"scale=%s",m->scalename);
                  formatline(buf);
             }
             fprintf(fp,"%s\n",buf);
     
             for (i=0;i<3;i++){
                if(m->scalefn==scalefunctions[i])
                    strcpy(scalefnnamestring,scalefnnames[i]);
             }
             sprintf(buf,"scalefn=%s",scalefnnamestring);
             formatline(buf);
             fprintf(fp,"%s\n",buf);

             fprintf(fp,"transpose=%d\n",m->transpose);

             fprintf(fp,"dmultiplier=%f\n",m->dmultiplier/4.0);
          }
        }
        fclose(fp);
        unsavedmapchanges=0;
        return 0;
}
